<?php
//==============================================================
// Program Name		: BookMark
// File Name		: bkmk_mente.php
//--------------------------------------------------------------
// Date             : 2000/07/25
// Author           : Satoshi Fujii
//--------------------------------------------------------------
// Note				: 
//                  : 
//--------------------------------------------------------------
// Rev.             : 
//                  : 
//==============================================================

require("jetjob.inc");
require("common_login.php");			// 
require("common_menu_change.inc");	// ˥塼
require("common_check.inc");		// 
require("bkmk_init.inc");			// ֥åޡ

define("BGCOLOR_1",	"#f7f2e8");


//==============================================================
// Function Name    : Delete_Link
//--------------------------------------------------------------
// Note		        : 󥯺
//                  :
//==============================================================
Function Delete_Link($LinkID)
{
	$db = new DB_Test;

	// 󥯺
	$db->query("DELETE FROM bkmk_link WHERE linkid = '$LinkID'");

	// 硼ȥ󥯺
	$sql = sprintf("DELETE FROM bkmk_digest WHERE linkid = '%s'", $LinkID);
	$db->query($sql);

	$db->close();
}


//==============================================================
// Function Name    : Delete_SubCategory
//--------------------------------------------------------------
// Note		        : ֥ƥ
//                  :
//==============================================================
Function Delete_SubCategory($SubCategoryID)
{
	$db = new DB_Test;
	
	// ֥ƥ
	$db->query("DELETE FROM bkmk_subcategory WHERE subcategoryid = '$SubCategoryID'");
	
	// Ϣ쥳ɺ
	$query = "SELECT linkid FROM bkmk_link WHERE subcategoryid = '$SubCategoryID'";
	$db->query($query);
	while ($db->next_record()) {
		Delete_Link($db->f("linkid"));
	}
	$db->close();
}


//==============================================================
// Function Name    : Delete_Category
//--------------------------------------------------------------
// Note		        : ƥ
//                  :
//==============================================================
Function Delete_Category($CategoryID)
{
	$db = new DB_Test;
	
	// ƥ
	$db->query("DELETE FROM bkmk_category WHERE categoryid = '$CategoryID'");
	
	// Ϣ쥳ɺ
	$query = "SELECT subcategoryid FROM bkmk_subcategory WHERE categoryid = '$CategoryID'";
	$db->query($query);
	while ($db->next_record()) {
		Delete_SubCategory($db->f("subcategoryid"));
	}	
	$db->close();
}


//==============================================================
// Function Name    : Update_Category
//--------------------------------------------------------------
// Note		        : 
//                  :
//==============================================================
Function Update_Category($category_id, $category_name)
{
	$db = new DB_Test;
	
	$category_name = str_kigouchk($category_name);
	if (!trim($category_name))	{	$category_name_tmp = "Null";	}
	else						{	$category_name_tmp = "'" . trim($category_name) . "'";	}

	$query = "UPDATE bkmk_category SET categoryname = $category_name_tmp";
	$query .= sprintf(" WHERE categoryid = '%s'", $category_id);
	$db->query($query);
	$db->close();
}


//==============================================================
// Function Name    : Update_SubCategory
//--------------------------------------------------------------
// Note		        : 
//                  :
//==============================================================
Function Update_SubCategory($id, $name)
{
	$db = new DB_Test;
	
	$name = str_kigouchk($name);
	if (!trim($name))	{	$name_tmp = "Null";	}
	else				{	$name_tmp = "'" . trim($name) . "'";	}

	$db->query("UPDATE bkmk_subcategory SET subcategoryname = $name_tmp WHERE subcategoryid = '$id'");
	$db->close();
}


//==============================================================
// Function Name    : Update_Link
//--------------------------------------------------------------
// Note		        : ֥åޡ
//                  :
//==============================================================
Function Update_Link($link_id, $title, $url, $comment)
{
	// URLʸ­
	if (substr($url, 0, 7) != "http://") {
		$url = "http://" . $url;
	}

	$title = str_kigouchk($title);
	if (!trim($title))	{	$title_tmp = "Null";	}
	else				{	$title_tmp = "'" . trim($title) . "'";	}
	$url = str_kigouchk($url);
	if (!trim($url))	{	$url_tmp = "Null";	}
	else				{	$url_tmp = "'" . trim($url) . "'";	}
	$comment = str_kigouchk($comment);
	if (!trim($comment))	{	$comment_tmp = "Null";	}
	else					{	$comment_tmp = "'" . trim($comment) . "'";	}

	$db = new DB_Test;
	$query = sprintf("UPDATE bkmk_link SET link_title=%s, url=%s, biko=%s WHERE linkid='%s'", 
				$title_tmp, $url_tmp, $comment_tmp, $link_id);
	$db->query($query);
	$db->close();
}


//==============================================================
// Function Name    : Print_Category
//--------------------------------------------------------------
// Note		        : 
//                  :
//==============================================================
Function Print_Category()
{
	// ᥤơ֥ Ϥޤ
	print("<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\"><tr>\n");
	print("<td valign=\"top\">\n");
	Print_Menu();
	print("</td>\n");
	print("<td width=\"10\" class=\"color00\"><br></td>\n");
	printf("<td valign=\"top\" bgcolor=\"white\" width=\"%d\">\n", PAGE_WIDTH);
	print("<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"5\">\n<tr>\n<td>\n");

	print("<table width=\"100%\" border=\"0\" cellspacing=\"2\" cellpadding=\"5\">\n");
	print("<tr><td colspan=\"3\" class=\"color02\">");
	print("<b><a href=\"bkmk_main.php?\">ۡ</a> -> </b></td></tr>\n");

	print("<tr><td colspan=\"3\">ƥ̾</td></tr>\n");

	$db = new DB_Test;
	$db->query("SELECT * FROM bkmk_category ORDER BY categoryid");	
	while ($db->next_record()) {
		$id = $db->f("categoryid");
		$name = $db->f("categoryname");
		printf("<form action=\"%s\" method=\"post\">\n", PG_NAME());
		print("<input type=\"hidden\" name=\"action\" value=\"update_category\">\n");
		print("<input type=\"hidden\" name=\"category_id\" value=$id>\n");
		printf("<tr bgcolor=\"%s\">\n<td>", BGCOLOR_1);
		printf("<input type=\"text\" size=30 name=\"category_name\" value=\"%s\">",htmlspecialchars($name));
		print(" <input type=\"submit\" value=\"̾ѹ\">");
		print("</td>\n</form>\n");
		printf("<td><form action=\"%s\" method=\"post\">\n", PG_NAME());
		print("<input type=\"hidden\" name=\"action\" value=\"delete_category\">\n");
		print("<input type=\"hidden\" name=\"category_id\" value=$id>\n");
		print("<input type=\"submit\" value=\"\">\n");
		print("</td>\n");
		printf("<td><a href=\"%s?category_id=$id&mode=sub_index\">֥ƥ</a></td>\n", PG_NAME());
		print("</tr>\n");
		print("</form>\n");
	}
	print("</table>\n");

	$db->close();
	
	// ᥤơ֥ 
	print("</td>\n</tr>\n</table>\n");
	print("</td>\n");
	print("<td width=\"10\" class=\"color00\"><br></td>");
	print("</tr></table>\n");
}


//==============================================================
// Function Name    : Print_SubCategory
//--------------------------------------------------------------
// Note		        : 
//                  :
//==============================================================
Function Print_SubCategory($CategoryID)
{
	$db = new DB_Test;
	
	$db->query("SELECT categoryname FROM bkmk_category WHERE categoryid = '$CategoryID'");
	$db->next_record();
	$title = $db->f("categoryname");
	
	// ᥤơ֥ Ϥޤ
	print("<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\"><tr>\n");
	print("<td valign=\"top\">\n");
	Print_Menu();
	print("</td>\n");
	print("<td width=\"10\" class=\"color00\"><br></td>\n");
	printf("<td valign=\"top\" bgcolor=\"white\" width=\"%d\">\n", PAGE_WIDTH);
	print("<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"5\">\n<tr>\n<td>\n");

	print("<table border=\"0\" cellspacing=\"2\" cellpadding=\"5\" width=\"100%\">\n");
	print("<tr><td colspan=\"3\" class=\"color02\">\n");
	printf("<b><a href=\"bkmk_main.php?\">ۡ</a> -> <a href=\"%s?\">ƥʥ</a> -></b>\n", 
		PG_NAME());
	printf("<br><font size=\"4\"><b>%s</b></font>\n", $title);
	print("</tr>\n");
	
	print("<tr>\n<td colspan=\"3\">֥ƥ̾</td>\n</tr>\n");

	$query = "SELECT * FROM bkmk_subcategory WHERE categoryid = '$CategoryID' ORDER BY subcategoryid";
	$db->query($query);
	while ($db->next_record()) {
		$id = $db->f("subcategoryid");
		$name = $db->f("subcategoryname");
		printf("<tr bgcolor=\"%s\">\n", BGCOLOR_1);
		printf("<form action=\"%s\" method=\"post\">\n", PG_NAME());
		print("<input type=\"hidden\" name=\"action\" value=\"update_subcategory\">\n");
		print("<input type=\"hidden\" name=\"subcategory_id\" value=$id>\n");
		print("<input type=\"hidden\" name=\"mode\" value=\"sub_index\">\n");
		print("<input type=\"hidden\" name=\"category_id\" value=\"$CategoryID\">\n");
		printf("<td><input type=\"text\" size=30 name=subcategory_name value=\"%s\">",htmlspecialchars($name));
		print("<input type=\"submit\" value=\"̾ѹ\">\n");
		print("</td>\n</form>\n");
		printf("<form action=\"%s\" method=\"post\">\n", PG_NAME());
		print("<input type=\"hidden\" name=\"action\" value=\"delete_subcategory\">\n");
		print("<input type=\"hidden\" name=\"subcategory_id\" value=$id>\n");
		print("<input type=\"hidden\" name=\"mode\" value=\"sub_index\">\n");
		print("<input type=\"hidden\" name=\"category_id\" value=\"$CategoryID\">\n");
		print("<td><input type=\"submit\" value=\"\">\n");
		print("</td>\n</form>\n");
		printf("<td><a href=\"%s?subcategory_id=$id&mode=link_index\">֥åޡ</a></td>\n", PG_NAME());
		print("</tr>\n");
	}
	print("</table>\n");

	$db->close();
	
	// ᥤơ֥ 
	print("</td>\n</tr>\n</table>\n");
	print("</td>\n");
	print("<td width=\"10\" class=\"color00\"><br></td>");
	print("</tr></table>\n");
}


//==============================================================
// Function Name    : Print_Link
//--------------------------------------------------------------
// Note		        : 󥯰ɽ
//                  :
//==============================================================
Function Print_Link($SubCategoryID)
{
	global $view_count, $view_count_list, $page;

	$db = new DB_Test;
	
	// ƥ֥̾ƥ̾
	$query = "SELECT bkmk_subcategory.subcategoryname, bkmk_category.categoryname, bkmk_category.categoryid ";
	$query .= " FROM bkmk_subcategory, bkmk_category ";
	$query .= " WHERE bkmk_subcategory.subcategoryid = '$SubCategoryID' AND bkmk_subcategory.categoryid = bkmk_category.categoryid";
	$db->query($query);
	$db->next_record();
	$category_id = $db->f("categoryid");
	$category_name = $db->f("categoryname");
	$subcategory_name = $db->f("subcategoryname");
	
	// ᥤơ֥ Ϥޤ
	print("<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\"><tr>\n");
	print("<td valign=\"top\">\n");
	Print_Menu();
	print("</td>\n");
	print("<td width=\"10\" class=\"color00\"><br></td>\n");
	printf("<td valign=\"top\" bgcolor=\"white\" width=\"%d\">\n", PAGE_WIDTH);
	print("<table border=\"0\" cellspacing=\"0\" cellpadding=\"5\" width=\"100%\">\n<tr>\n<td>\n");
	
	print("<table border=\"0\" cellspacing=\"2\" cellpadding=\"5\" width=\"100%\">\n");
	
	// ȥɽ
	print("<tr>\n");
	print("<td colspan=\"4\" class=\"color02\"><b>");
	printf("<a href=\"bkmk_main.php?\">ۡ</a> -> <a href=\"%s?\">ƥʥ</a> -> \n", PG_NAME());
	printf("<a href=\"%s?mode=sub_index&category_id=$category_id\">%s</a> -> ", 
		PG_NAME(), htmlspecialchars($category_name));
	printf("<br><font size=\"4\">%s</font>", htmlspecialchars($subcategory_name));
	print("</b></td>\n");
	print("</tr>\n");

	// ڡ
	if (!$view_count) {
		$view_count = $view_count_list[0];
	}
	if (!isset($page))	$page=0;
	$start_row = $page * $view_count;
	$end_row = $start_row + $view_count;

	// ơ֥إåɽ
	print("<tr align=\"center\" class=\"color01\">\n");
	print("<td><b>ȥ</b></td>\n");
	print("<td><b>URL</b></td>\n");
	print("<td><b></b></td>\n");
	print("<td><b></b></td>\n");
	print("</tr>\n");

	$sql = "SELECT * FROM bkmk_link WHERE subcategoryid = '$SubCategoryID' ORDER BY linkid";
	$db->query($sql);
	$loop_count = 0;
	while ($db->next_record()) 
	{
		if ($loop_count < $start_row || $loop_count >= $end_row) {
			$loop_count++;
			continue;
		}
		
		$upd_img = sprintf("<img src=\"%s\" alt=\"\" width=\"36\" height=\"16\" border=\"0\">", UPDATE_IMG);
		$del_img = sprintf("<img src=\"%s\" alt=\"\" width=\"36\" height=\"16\" border=\"0\">", DELETE_IMG);
		
		print("<tr bgcolor=\"#f7f2e8\">\n");
		printf("<td width=\"140\">%s</td>\n", $db->f("link_title"));
		printf("<td width=\"160\">%s</td>\n", $db->f("url"));
		printf("<td align=\"center\"><a href=\"%s?mode=link_view&link_id=%s\">%s</a></td>\n", 
			PG_NAME(), $db->f("linkid"), $upd_img);
		printf("<td align=\"center\"><a href=\"%s?link_id=%s&subcategory_id=%s&mode=link_index&action=delete_link\">", 
			PG_NAME(), $db->f("linkid"), $db->f("subcategoryid"));
		printf("%s</a></td>\n", $del_img);
		print("</tr>\n");
		$loop_count++;
	}
	print("</table>\n");

	// 쥳ɷ
	$query = "SELECT COUNT(linkid) AS cnt FROM bkmk_link WHERE subcategoryid = '$SubCategoryID'";
	$db->query($query);
	$db->next_record();
	$link_count = $db->f("cnt");

	// ڡưɽ
	print("<table width=\"100%\"><tr align=\"center\">\n");
	if ($start_row) {
		printf("<td width=\"50%%\"><a href=\"%s?mode=%s&subcategory_id=%s&page=%d\">\n", 
			PG_NAME(), "link_index", $SubCategoryID, $page - 1);
		printf("<img src=\"%s\" border=\"0\" alt=\"Υڡ\">", BACK_IMG);
		print("</a></td>\n");
	} else {
		print("<td width=\"50%\"><br></td>\n");
	}
	if ($link_count > $end_row) {
		printf("<td width=\"50%%\"><a href=\"%s?mode=%s&subcategory_id=%s&page=%d\">\n", 
			PG_NAME(), "link_index", $SubCategoryID, $page + 1);
		printf("<img src=\"%s\" border=\"0\" alt=\"Υڡ\">", NEXT_IMG);
		print("</a></td>\n");
	} else {
		print("<td width=\"50%\"><br></td>\n");
	}
	print("</tr></table>\n");

	// ɽեɽ
	Print_ViewCountForm(PG_NAME(), "link_index", $SubCategoryID);

	$db->close();
	
	// ᥤơ֥ 
	print("</td>\n</tr>\n</table>\n");
	print("</td>\n");
	print("<td width=\"10\" class=\"color00\"><br></td>");
	print("</tr></table>\n");
}


//==============================================================
// Function Name    : Print_UpdateForm
//--------------------------------------------------------------
// Note		        : 
//                  :
//==============================================================
Function Print_UpdateForm($link_id)
{
	$db = new DB_Test;
	
	// ӥ塼ǡ
//	$query = "SELECT * FROM bkmk_linkview WHERE linkid = '$link_id'";
	$query = "SELECT bkmk_category.categoryid, bkmk_category.categoryname, bkmk_subcategory.subcategoryid, bkmk_subcategory.subcategoryname, bkmk_link.link_title, bkmk_link.url, bkmk_link.biko ";
	$query .= " FROM bkmk_category, bkmk_subcategory, bkmk_link";
	$query .= " WHERE bkmk_category.categoryid = bkmk_subcategory.categoryid";
	$query .= " AND bkmk_subcategory.subcategoryid = bkmk_link.subcategoryid";
	$query .= " AND bkmk_link.linkid = '$link_id'";
	$db->query($query);
	$db->next_record();
	$cate_id = $db->f("categoryid");
	$cate_name = $db->f("categoryname");
	$subcate_id = $db->f("subcategoryid");
	$subcate_name = $db->f("subcategoryname");
	$title = $db->f("link_title");
	$url = $db->f("url");
	$comment = $db->f("biko");
	
	// JavaScript
	?>
	<script language="JavaScript">
	<!--
		function submit_form(form) {
			if (form.title.value == '') {
				alert('ȥ뤬ϤƤޤ');
				form.title.focus();
				return;
			}
			if (form.url.value == '') {
				alert('URLϤƤޤ');
				form.url.focus();
				return;
			}
			if (form.comment.value.length > 100) {
				alert('ȤʸĹޤ');
				form.comment.focus();
				return;
			}
			form.submit();
		}
	// -->
	</script>
	<?
	
	// ᥤơ֥ Ϥޤ
	print("<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\"><tr>\n");
	print("<td valign=\"top\">\n");
	Print_Menu();
	print("</td>\n");
	print("<td width=\"10\" class=\"color00\"><br></td>\n");
	printf("<td valign=\"top\" align=\"center\" bgcolor=\"white\" width=\"%d\">\n", PAGE_WIDTH);
	print("<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"5\"><tr>\n<td>\n");

	// ȥɽ
	print("<table border=\"0\" cellspacing=\"2\" cellpadding=\"5\" width=\"100%\"><tr>\n");
	print("<td colspan=\"2\" class=\"color02\"><b>");
	printf("<a href=\"%s?\">ۡ</a> -> <a href=\"%s?\">ƥʥ</a> -> \n", TOP_PAGE, PG_NAME());
	printf("<a href=\"%s?mode=sub_index&category_id=$cate_id\">%s</a> -> ", PG_NAME(),htmlspecialchars($cate_name));
	printf("<a href=\"%s?mode=link_index&subcategory_id=$subcate_id\">%s</a> -> ", PG_NAME(),htmlspecialchars($subcate_name));
	printf("<br><font size=\"4\">%s</font>", $title);
	print("</b></td></tr>\n");

	// եɽ
	printf("<form action=\"%s\" method=\"post\">\n", PG_NAME());
	print("<tr>\n");
	print("<td class=\"color01\"><b>ȥ(ɬ)</b></td>\n");
	print("<td bgcolor=\"#f7f2e8\">\n");
	printf("<input type=\"text\" size=\"50\" maxlength=\"50\" name=\"title\" value=\"%s\">\n",
			htmlspecialchars($title));
	print("</td></tr>\n");
	print("<tr><td class=\"color01\"><b>գң(ɬ)</b></td>\n");
	print("<td bgcolor=\"#f7f2e8\">\n");
	printf("<input type=\"text\" size=\"50\" name=\"url\" value=\"%s\">\n",htmlspecialchars($url));
	print("</td></tr>\n");
	print("<tr><td class=\"color01\"><b></b></td>\n");
	print("<td bgcolor=\"#f7f2e8\">\n");
	print("<textarea name=\"comment\" wrap=\"soft\" cols=50 rows=5>\n");
	printf("%s",htmlspecialchars($comment));
	print("</textarea>\n");
	print("</td></tr>\n");
	print("<tr><td colspan=2 align=\"center\">\n");
	print("<input type=\"hidden\" name=\"action\" value=\"update\">\n");
	print("<input type=\"hidden\" name=\"link_id\" value=\"$link_id\">\n");
	print("<input type=\"hidden\" name=\"mode\" value=\"link_index\">\n");
	print("<input type=\"hidden\" name=\"subcategory_id\" value=\"$subcate_id\">\n");
	print("<input type=\"button\" value=\"  \" onclick=\"submit_form(this.form);\">\n");
	print("</td></tr>\n");
	print("</form>\n</table>\n");
	
	$db->close();
	
	// ᥤơ֥ 
	print("</td>\n</tr>\n</table>\n");
	print("</td>\n");
	print("<td width=\"10\" class=\"color00\"><br></td>");
	print("</tr></table>\n");
}


//==============================================================
// Function Name    : Program_Start
//--------------------------------------------------------------
// Note		        : 
//                  :
//==============================================================
Login_Start(PG_NAME());//å

include("common_printheader.inc");

if (!isset($action)) $action = "";
if (!isset($mode)) $mode = "";
switch ($action) {
	case "delete_category":
		Delete_Category($category_id);
		break;
	case "delete_subcategory":
		Delete_SubCategory($subcategory_id);
		break;
	case "delete_link":
		Delete_Link($link_id);
		break;
	case "update_category":
		Update_Category($category_id, $category_name);
		break;
	case "update_subcategory":
		Update_SubCategory($subcategory_id, $subcategory_name);
		break;
	case "update":
		Update_Link($link_id, $title, $url, $comment);
}

switch ($mode) {
	case "link_view":
		Print_UpdateForm($link_id);
		break;
	case "link_index":
		Print_Link($subcategory_id);
		break;
	case "sub_index":
		Print_SubCategory($category_id);
		break;
	default:
		Print_Category();
}

include("common_printfooter.inc");

?>
