<?php
//==============================================================
// Program Name     : 
// File Name        : 
//--------------------------------------------------------------
// Date             : 2000/11/28
// Author           : aquaplan networks
//--------------------------------------------------------------
// Note             : 
//                  : 
//--------------------------------------------------------------
// Rev.             : 
//                  : 
//==============================================================

require("jetjob.inc");
require("common_kanji.inc");

$ver=phpversion();
if ($ver[0] == "3")
$inc_file = "common_check_strpos_php3.inc";
// -- 2007/02/09 netnee ikarashi
//else if ($ver[0] == "4")
else
// -- 2007/02/09 netnee ikarashi
$inc_file = "common_check_strpos_php4.inc";
require_once($inc_file);

	function getContentType($inFileName)
	{
		//--strip path
		$inFileName = basename($inFileName);
		//--check for no extension
		if(strrchr($inFileName,".") == false)
		{
			return "application/octet-stream";
		}
		//--get extension and check cases
		$extension = strrchr($inFileName, ".");
		$lower_extension = strtolower($extension);
		switch ($lower_extension)
		{
			case ".gz":		return "application/x-gzip";
			case ".htm":	return "text/html";
			case ".html":	return "text//html";
			case ".gif":	return "image/gif";
			case ".jpg":	return "image/jpeg";
			case ".jpeg":	return "image/jpeg";
			case ".jpe":	return "image/jpeg";
			case ".tar":	return "application/x-tar";
			case ".txt":	return "text/plain";
			case ".zip":	return "application/zip";
			case ".lzh":	return "application/lzh";
			case ".dwg":	return "application/acad";
			case ".ccad":	return "application/clariscad";
			case ".drw":	return "application/drafting";
			case ".dxf":	return "application/dxf";
			case ".unv":	return "application/i-deas";
			case ".igs":	return "application/iges";
			case ".iges":	return "application/iges";
			case ".oda":	return "application/oda";
			case ".pdf":	return "application/pdf";
			case ".ai":		return "application/postscript";
			case ".ps":		return "application/postscript";
			case ".eps":	return "application/postscript";
			case ".prt":	return "application/pro_eng";
			case ".rtf":	return "application/rtf";
			case ".set":	return "application/set";
			case ".stl":	return "application/sla";
			case ".sol":	return "application/solids";
			case ".stp":	return "application/STEP";
			case ".step":	return "application/STEP";
			case ".vda":	return "application/vda";
			case ".mif":	return "application/x-mif";
			case ".csh":	return "application/x-csh";
			case ".dvi":	return "application/x-dvi";
			case ".hdf":	return "application/x-hdf";
			case ".latex":	return "application/x-latex";
			case ".nc":		return "application/x-netcdf";
			case ".cdf":	return "application/x-netcdf";
			case ".sh":		return "application/x-sh";
			case ".tcl":	return "application/x-tcl";
			case ".tex":	return "application/x-tex";
			case ".texinfo":return "application/x-texinfo";
			case ".texi":	return "application/x-texinfo";
			case ".t":		return "application/x-troff";
			case ".tr":		return "application/x-troff";
			case ".roff":	return "application/x-troff";
			case ".man":	return "application/x-troff-man";
			case ".me":		return "application/x-troff-me";
			case ".ms":		return "application/x-troff-ms";
			case ".src":	return "application/x-wais-source";
			case ".bcpio":	return "application/x-bcpio";
			case ".cpio":	return "application/x-cpio";
			case ".gtar":	return "application/x-gtar";
			case ".shar":	return "application/x-shar";
			case ".sv4cpio":return "application/x-sv4cpio";
			case ".sv4crc":	return "application/x-sv4crc";
			case ".ustar":	return "application/x-ustar";
			case ".au":		return "audio/basic";
			case ".snd":	return "audio/basic";
			case ".aif":	return "audio/aiff";
			case ".aiff":	return "audio/aiff";
			case ".aifc":	return "audio/aiff";
			case ".wav":	return "audio/wav";
			case ".ief":	return "image/ief";
			case ".tiff":	return "image/tiff";
			case ".tif":	return "image/tiff";
			case ".ras":	return "image/x-cmu-raster";
			case ".pnm":	return "image/x-portable-anymap";
			case ".pbm":	return "image/x-portable-bitmap";
			case ".pgm":	return "image/x-portable-graymap";
			case ".ppm":	return "image/x-portable-pixmap";
			case ".rgb":	return "image/x-rgb";
			case ".xbm":	return "image/x-xbitmap";
			case ".xpm":	return "image/x-xpixmap";
			case ".xwd":	return "image/x-xwindowdump";
			case ".rtx":	return "text/richtext";
			case ".tsv":	return "text/tab-separated-values";
			case ".etx":	return "text/x-setext";
			case ".mpeg":	return "video/mpeg";
			case ".mpg":	return "video/mpeg";
			case ".mpeg":	return "video/mpeg";
			case ".mpe":	return "video/mpeg";
			case ".qt":		return "video/quicktime";
			case ".mov":	return "video/quicktime";
			case ".avi":	return "video/x-msvideo";
			case ".movie":	return "video/x-sgi-msmovie";

			case ".xdw":	return "application/vnd.fujixerox.docuworks";
			case ".pdf":	return "application/pdf";
			case ".xls":	return "application/vnd.ms-excel";
			case ".ppt":	return "application/vnd.ms-powerpoint";
			case ".doc":	return "application/vnd.ms-word";

			default:		return "application/octet-stream";
		}
	}

//==============================================================
//
// $downloadname -> ɤե̾
// $downloadfile -> ɸΥե̾
// $contenttype  ->
//
//==============================================================

	$realname=urldecode($downloadname);

	// Check Output Charset
	//
	if (strtolower($JJ_OUTPUT_CHARSET) == "euc-jp")
		$FROM_CHARSET = EUC;
	else
		$FROM_CHARSET = SJIS;

	// Check User_Agent
	//
	$user_agent = strtolower(getenv("HTTP_USER_AGENT"));
	$win_flg = strpos($user_agent, "windows");
	$mac_flg = strpos($user_agent, "mac");

	if ((check_strpos_result($win_flg) == false) && (check_strpos_result($mac_flg) == false))
	{
		$realdownloadname = toStringEUC($realname, $FROM_CHARSET);
	}
	else
	{
		$realdownloadname = toStringSJIS($realname, $FROM_CHARSET);
	}
	/*
	$h = sprintf("Content-Disposition: inline; filename=\"%s\" \r\n Content-type: %s", $realdownloadname, $contenttype);
	header($h);
	*/
	$ctype = getContentType($realdownloadname);
	$str1 = "Content-disposition: inline; filename=$realdownloadname";
	//$str2 = "Content-Type: application/octet-stream";
	$str2 = "Content-Type: $ctype";
	header($str1);
	header($str2);

	readfile($downloadfile);
?>
