<?php
//==============================================================
// Program Name		: 塼븡
// File Name		: sche_find.php
//--------------------------------------------------------------
// Date             : 2002/02/26
// Author           : S Fujii
//--------------------------------------------------------------
// Note				: 
//                  : 
//--------------------------------------------------------------
// Rev.             : 
//                  : 
//==============================================================

require("jetjob.inc");
require("sche_commonfunction.inc");		// 塼붦̴ؿ


//==============================================================
// Function Name    : CreateSQL
//--------------------------------------------------------------
// Note		        : 
//                  : 
//==============================================================
Function CreateSQL($table_name)
{
	global $date_sel, $f_year, $f_month, $f_day, $t_year, $t_month, $t_day, $data_type, $kensaku, $opt;
	global $JJ_USE_DATABASE, $JJ_DATE_SIEGE;

	$query_str = sprintf("SELECT * FROM %s WHERE schedule_id <> ''", $table_name);

	if ($date_sel) 
	{
		$query_str .= sprintf(" AND hi >= %s%04d-%02d-%02d%s AND hi <= %s%04d-%02d-%02d%s", 
							$JJ_DATE_SIEGE, $f_year, $f_month, $f_day, $JJ_DATE_SIEGE, 
							$JJ_DATE_SIEGE, $t_year, $t_month, $t_day, $JJ_DATE_SIEGE);
	}
	
	if ($data_type) 
		$query_str .= sprintf(" AND data_type_id = '%s'", $data_type);
	
	if (!empty($kensaku))
	{
		$word_array = explode(" ", $kensaku);
		
		$query_str .= " AND (";
		for ($i = 0; $i < count($word_array); $i++) 
		{
			$val_i = str_kigouchk($word_array[$i]);
			
			if ($JJ_USE_DATABASE != "jet")
				$val_i = str_yen($val_i);
				
			if ($i != 0)
				$query_str .= sprintf(" %s biko like '%%%s%%'", $opt, $val_i);
			else
				$query_str .= sprintf("biko like '%%%s%%'", $val_i);
		}
		$query_str .= ")";
	}
	$query_str .= " ORDER BY hi, fzi";
	
	return $query_str;
}


//==============================================================
// Function Name    : PrintPrivateResult
//--------------------------------------------------------------
// Note		        : 
//                  : 
//==============================================================
Function PrintPrivateResult()
{
	global $JJ_USER_ID;
	
	print("<table width=\"100%\" border=\"0\" cellpadding=\"5\" cellspacing=\"3\">\n");
	
	$query_str = CreateSQL(TBL_DATA);
	
	$db = new DB_Test;
	$db->query($query_str);
	if ($db->nf() > 0) 
	{
		print("<tr>\n");
		printf("<td colspan=\"2\"><b>Ŀͥ塼椫 %dͽ꤬פޤ</b></td>\n", $db->nf());
		print("</tr>\n");
		print("<tr class=\"color02\" align=\"center\">\n");
		print("<td width=\"30%%\"><b></b></td>\n");
		print("<td width=\"70%%\"><b>//</b></td>\n");
		print("</tr>\n");
		while ($db->next_record()) 
		{
			$schedule_id = $db->f("schedule_id");
			$date = date_format_jj($db->f("hi"));
			$buf = explode(":", $db->f("fzi"));
			$from_time = sprintf("%d:%02d", $buf[0], $buf[1]);
			$buf = explode(":", $db->f("tzi"));
			$to_time = sprintf("%d:%02d", $buf[0], $buf[1]);
			$data_type	= GetDataType($db->f("data_type_id"));
			$biko		= $db->f("biko");
			$color		= GetScheduleColor($db->f("data_type_id"));
			$is_public	= $db->f("public_data");
			
			Get_Dayoftheweek($db->f("hi"), $youbi, $bg_color, $font_color);
			
			if (!$is_public)
				$img = sprintf("<img src=\"%s\" width=\"16\" height=\"16\" border=\"0\" alt=\"\">\n", KEY_GIF);
			else
				$img = "";
				
			if (IsDestination($schedule_id, $JJ_USER_ID))
				$img .= DEST_MARK;
			
			print("<tr bgcolor=\"#f7f2e8\">\n");
			printf("<td width=\"30%%\">%s (%s)</td>\n",  $date, $youbi);
			printf("<td width=\"70%%\"><font color=\"%s\"></font><a href=\"sche_private.php?mode=view&hi=%s&no=%s\">%s%s %s %s</a>%s</td>\n", 
				$color, $db->f("hi"), $schedule_id, $from_time, $to_time, $data_type, $biko, $img);
			print("</tr>\n");
		}
	} 
	else 
	{
		print("<tr>\n");
		print("<td colspan=\"2\"><b>Ŀͥ塼˳ǡϤߤĤޤǤ</b></td>\n");
		print("</tr>\n");
	}
	$db->close();

	print("</table>\n");
}


//==============================================================
// Function Name    : PrintGroupResult
//--------------------------------------------------------------
// Note		        : 
//                  : 
//==============================================================
Function PrintGroupResult()
{
	$sql = CreateSQL("sche_groupdata");

	print("<table width=\"100%\" border=\"0\" cellpadding=\"5\" cellspacing=\"3\">\n");
	
	$db = new DB_Test;
	$db->query($sql);
	$count = $db->nf();
	if ($count > 0)
	{
		print("<tr>\n");
		printf("<td colspan=\"2\"><b>롼ץ塼椫 %dͽ꤬פޤ</b></td>\n", $count);
		print("</tr>\n");
		print("<tr class=\"color02\" align=\"center\">\n");
		print("<td width=\"30%%\"><b></b></td>\n");
		print("<td width=\"70%%\"><b>//</b></td>\n");
		print("</tr>\n");

		while ($db->next_record())
		{
			$date			= date_format_jj($db->f("hi"));
			$from_time		= Time_Format($db->f("fzi"));
			$to_time		= Time_Format($db->f("tzi"));
			$biko			= $db->f("biko");
			$data_type_id	= $db->f("data_type_id");
			$data_type		= GetDataType($data_type_id);
			$group_id		= $db->f("group_id");
			$group_type		= $db->f("group_type");
			$color			= GetScheduleColor($data_type_id);
			
			Get_Dayoftheweek($db->f("hi"), $youbi, $bg_color, $font_color);
			
			if ($group_type == GROUPTYPE_SECTION)
				$prefix = SECTIONID_PREFIX;
			else
				$prefix = GROUPID_PREFIX;
			$group_id = sprintf("%s%s%s", $prefix, PREFIX_SPLITTER, $group_id);
			
			$link = sprintf("sche_group.php?mode=3&hiduke=%s&schedule_id=%s&new_section_id=%s",
						$db->f("hi"), $db->f("schedule_id"), $group_id);
			
			print("<tr bgcolor=\"#f7f2e8\">\n");
			printf("<td width=\"30%%\">%s (%s)</td>\n", $date, $youbi);
			printf("<td width=\"70%%\"><font color=\"%s\"></font><a href=\"%s\">%s%s %s %s</a></td>\n", 
				$color, $link, $from_time, $to_time, $data_type, $biko);
			print("</tr>\n");
		}
	}
	else
	{
		print("<tr>\n");
		print("<td colspan=\"2\"><b>롼ץ塼˳ǡϤߤĤޤǤ</b></td>\n");
		print("</tr>\n");
	}
	$db->close();
		
	print("</table>\n");
}


//==============================================================
// Function Name    : PrintPublicResult
//--------------------------------------------------------------
// Note		        : 
//                  : 
//==============================================================
Function PrintPublicResult()
{
	print("<table width=\"100%\" border=\"0\" cellpadding=\"5\" cellspacing=\"3\">\n");
	
	$query_str = CreateSQL(PUBLIC_TABLE);
	
	$db = new DB_Test;
	$db->query($query_str);
	if ($db->nf() > 0) 
	{
		print("<tr>\n");
		printf("<td colspan=\"2\"><b>ҥ塼椫 %dͽ꤬פޤ</b></td>\n", $db->nf());
		print("</tr>\n");
		print("<tr class=\"color02\" align=\"center\">\n");
		print("<td width=\"30%%\"><b></b></td>\n");
		print("<td width=\"70%%\"><b>//</b></td>\n");
		print("</tr>\n");
		while ($db->next_record()) 
		{
			$date = date_format_jj($db->f("hi"));
			$buf = explode(":", $db->f("fzi"));
			$from_time = sprintf("%d:%02d", $buf[0], $buf[1]);
			$buf = explode(":", $db->f("tzi"));
			$to_time = sprintf("%d:%02d", $buf[0], $buf[1]);
			$data_type	= GetDataType($db->f("data_type_id"));
			$biko		= $db->f("biko");
			$color		= GetScheduleColor($db->f("data_type_id"));
			
			Get_Dayoftheweek($db->f("hi"), $youbi, $bg_color, $font_color);
			
			$link = sprintf("sche_all.php?mode=3&hiduke=%s&schedule_id=%s",
						$db->f("hi"), $db->f("schedule_id"));
			
			print("<tr bgcolor=\"#f7f2e8\">\n");
			printf("<td width=\"30%%\">%s (%s)</td>\n",  $date, $youbi);
			printf("<td width=\"70%%\"><font color=\"%s\"></font><a href=\"%s\">%s%s %s %s</a></td>\n", 
				$color, $link, $from_time, $to_time, $data_type, $biko);
			print("</tr>\n");
		}
	} 
	else 
	{
		print("<tr>\n");
		print("<td colspan=\"2\"><b>ҥ塼˳ǡϤߤĤޤǤ</b></td>\n");
		print("</tr>\n");
	}
	$db->close();

	print("</table>\n");
}


//==============================================================
// Function Name    : Print_FindPage
//--------------------------------------------------------------
// Note		        : ǡڡ
//                  : 
//==============================================================
Function Print_FindPage()
{
	global $kensaku, $opt, $date_sel, $f_year, $f_month, $f_day, $t_year, $t_month, $t_day, $data_type;
	global $JJ_USER_ID;

	$from_date	= sprintf("%04d-%02d-%02d", $f_year, $f_month, $f_day);
	$to_date	= sprintf("%04d-%02d-%02d", $t_year, $t_month, $t_day);

	// ͭå
	if ($date_sel)
	{
		if (!checkdate($f_month, $f_day, $f_year) || 
			!checkdate($t_month, $t_day, $t_year) || 
			$from_date >= $to_date) {
				print("<p>դͭǤϤޤ</p>\n");
				print("</td></tr></table>\n");
				return;
		}
	}

	print("<table width=\"100%\" border=\"0\" cellpadding=\"5\" cellspacing=\"2\">\n");
	printf("<form action=\"%s\" method=\"post\">\n", PG_NAME());
	
	// ոɽ
	$current_year = date("Y");
	print("<tr><td class=\"color01\"><b></b></td><td bgcolor=\"#f7f2e8\">\n");
	if ($date_sel) {
		print("<input type=\"radio\" name=\"date_sel\" value=\"0\">ʤ<br>\n");
		print("<input type=\"radio\" name=\"date_sel\" value=\"1\" checked>\n");
	} else {
		print("<input type=\"radio\" name=\"date_sel\" value=\"0\" checked>ʤ<br>\n");
		print("<input type=\"radio\" name=\"date_sel\" value=\"1\">\n");
	}
	print("<select name=\"f_year\">\n");
	for ($i=$current_year+1; $i>$current_year-5; $i--) {
//		if ($f_year == $i) {
		if ($current_year == $i) {
			printf("<option value=\"%04d\" selected>%dǯ</option>\n", $i, $i);
		} else {
			printf("<option value=\"%04d\">%dǯ</option>\n", $i, $i);
		}
	}
	print("</select>\n");
	print("<select name=\"f_month\">\n");
	for ($i=1; $i<=12; $i++) {
		if ($f_month == $i) {
			printf("<option value=\"%02d\" selected>%d</option>\n", $i, $i);
		} else {
			printf("<option value=\"%02d\">%d</option>\n", $i, $i);
		}
	}
	print("</select>\n");
	print("<select name=\"f_day\">\n");
	for ($i=1; $i<=31; $i++) {
		if ($f_day == $i) {
			printf("<option value=\"%02d\" selected>%d</option>\n", $i, $i);
		} else {
			printf("<option value=\"%02d\">%d</option>\n", $i, $i);
		}
	}
	print("</select> \n");
	print("<select name=\"t_year\">\n");
	for ($i=$current_year+1; $i>$current_year-5; $i--) {
//		if ($t_year == $i) {
		if ($current_year == $i) {
			printf("<option value=\"%04d\" selected>%dǯ</option>\n", $i, $i);
		} else {
			printf("<option value=\"%04d\">%dǯ</option>\n", $i, $i);
		}
	}
	print("</select>\n");
	print("<select name=\"t_month\">\n");
	for ($i=1; $i<=12; $i++) {
		if ($t_month == $i) {
			printf("<option value=\"%02d\" selected>%d</option>\n", $i, $i);
		} else {
			printf("<option value=\"%02d\">%d</option>\n", $i, $i);
		}
	}
	print("</select>\n");
	print("<select name=\"t_day\">\n");
	for ($i=1; $i<=31; $i++) {
		if ($t_day == $i) {
			printf("<option value=\"%02d\" selected>%d</option>\n", $i, $i);
		} else {
			printf("<option value=\"%02d\">%d</option>\n", $i, $i);
		}
	}
	print("</select> ͽ\n");
	print("</td></tr>\n");
	
	// ͽ̸ɽ
	print("<tr>\n");
	print("<td class=\"color01\"><b>ͽ</b></td><td bgcolor=\"#f7f2e8\"><select name=\"data_type\">\n");
	print("<option value=\"0\">ʤ</option>\n");
	$data_type_array = Get_DataTypeArray($JJ_USER_ID);
	if ($data_type_array) 
	{
		while (list($key, $val) = each($data_type_array)) 
		{
			if ($data_type == $key)
				printf("<option value=\"%s\" selected>%s</option>\n", $key, htmlspecialchars($val));
			else
				printf("<option value=\"%s\">%s</option>\n", $key, htmlspecialchars($val));
		}
	}
	print("</select></td>\n");
	print("</tr>\n");
	
	// ⸡ɽ
	print("<tr><td class=\"color01\"><b></b></td><td bgcolor=\"#f7f2e8\">\n");
	printf("<INPUT type=\"text\" size=\"50\" maxlength=\"50\" name=\"kensaku\" value=\"%s\"><br>\n", htmlspecialchars($kensaku));
	if ($opt == "or") 
	{
		print("<input type=\"radio\" name=\"opt\" value=\"and\">\n");
		print("<input type=\"radio\" name=\"opt\" value=\"or\" checked>ޤ\n");
	} 
	else 
	{
		print("<input type=\"radio\" name=\"opt\" value=\"and\" checked>\n");
		print("<input type=\"radio\" name=\"opt\" value=\"or\">ޤ\n");
	}
	print("</td></tr>\n");
	
	print("<tr><td align=\"center\" colspan=\"2\">\n");
	print("<input type=\"submit\" value=\"  \">\n");
	print("</td></tr>\n");
	
	print("</form>\n");
	print("</table>\n");

	// ɽ
	if ($kensaku || $date_sel || $data_type) 
	{
		if (TBL_UMUChk(TBL_DATA))
		{
			print("<hr>\n");
			PrintPrivateResult();
		}
		
		print("<hr>\n");
		PrintGroupResult();
	
		if (TBL_UMUChk(PUBLIC_TABLE)) 
		{
			print("<hr>\n");
			PrintPublicResult();
		}
	}
}


//==============================================================
// Function Name    : Program_Start
//--------------------------------------------------------------
// Note		        : 
//                  : 
//==============================================================

Login_Start(PG_NAME());

include("common_printheader.inc");

// ˥塼ʬɽ
Print_Menu(4);

print("<table width=\"590\" bgcolor=\"white\" cellpadding=\"5\" cellspacing=\"0\" border=\"0\">\n");
print("<tr><td align=\"center\">\n");

Print_FindPage();

print("</td></tr></table>\n");

include("common_printfooter.inc");

?>
