<?php
//==============================================================
// Program Name		: Υ塼
// File Name		: sche_guntchart.php
//--------------------------------------------------------------
// Date             : 2002/02/13
// Author           : S Fujii
//--------------------------------------------------------------
// Note				: 롼ץ塼ɽ
//                  : 
//--------------------------------------------------------------
// Rev.             : 
//                  : 
//==============================================================

require("jetjob.inc");
require("sche_commonfunction.inc");		// 塼붦̴ؿ

define("DAY_CHART_WIDTH", "20");			// ɽΣޥ
define("WEEK_CHART_WIDTH", "60");			// ɽΣޥ
define("MONTH_CHART_WIDTH", "13");			// ɽΣޥ
define("OTHER_SCHEDULE_COLOR", "#ffff99");	// ʣͽο

define("SCHE_MAIN_PG", "sche_main.php");	// Ŀɽץ

define("IMG_YOTEI",	$JJ_IMG_ROOT . "body/sched_all_month.gif");	// ͽ꤬ȤΥ

// ɽ
$sel_array = array(VIEWTYPE_DAY => "ɽ", VIEWTYPE_WEEK => "ɽ", VIEWTYPE_MONTH => "ɽ");


//==============================================================
// Function Name    : Get_GroupMemberQuery
//--------------------------------------------------------------
// Note		        : ӣѣ̺
//                  :
//==============================================================
Function Get_GroupMemberQuery()
{
	global $group;
	
	$tmp = explode("-", $group);
	if ($tmp[0] == "sec") {	// °
		$query_str = sprintf("SELECT member_id, member_name FROM common_member WHERE section_id = '%s' ORDER BY furigana", 
						$tmp[1]);
	} elseif ($tmp[0] == "grp") {	// ޥ롼
		$query_str = sprintf("SELECT common_group_member.member_id, common_member.member_name FROM common_group_member, common_member WHERE common_group_member.member_id = common_member.member_id AND  group_id = '%s' ORDER BY furigana", $tmp[1]);
	} else {
		$query_str = "SELECT member_id, member_name FROM common_member ORDER BY furigana";
	}
	return $query_str;
}


//==============================================================
// Function Name    : Print_ViewChangeForm
//--------------------------------------------------------------
// Note		        : 
//                  :
//==============================================================
Function Print_ViewChangeForm()
{
	global $hiduke, $group, $viewtype;
	global $JJ_USER_ID;
	global $sel_array;
	
	$db = new DB_Test;
	
	// °
	$query_str = "SELECT * FROM common_section ORDER BY section_id";
	$db->query($query_str);
	while ($db->next_record()) {
		$section_array[$db->f("section_id")] = $db->f("section_name");
	}
	
	// 롼׼
	$query_str = sprintf("SELECT * FROM common_group WHERE (member_id = '%s') OR (common_flg <> '') ORDER BY group_id", 
					$JJ_USER_ID);
	$db->query($query_str);
	if (!isset($group_array))	$group_array=array();
	while ($db->next_record()) {
		$group_array[$db->f("group_id")] = $db->f("group_name");
	}

	// 롼׽ ʬν°
	if (!$group) {
		$query_str = sprintf("SELECT * FROM common_member WHERE member_id = '%s'", $JJ_USER_ID);
		$db->query($query_str);
		$db->next_record();
		$group = sprintf("sec-%s", $db->f("section_id"));
	}

	print("<table width=\"100%\" cellspacing=\"3\" cellpadding=\"5\">\n");
	printf("<form name=\"view_form\" action=\"%s\" method=\"post\">\n", PG_NAME());
	printf("<input type=\"hidden\" name=\"hiduke\" value=\"%s\">\n", $hiduke);
	print("<tr><td>\n");
	
	print("ɽ롼<select name=\"new_group\" onChange=\"document.view_form.submit();\">\n");
	print("<option value=\"0\">--- ° ---</option>\n");
	while (list($id, $name) = each($section_array)) {
		if ($group == sprintf("sec-%s", $id)) {
			printf("<option value=\"sec-%s\" selected>%s</option>\n", $id, htmlspecialchars($name));
		} else {
			printf("<option value=\"sec-%s\">%s</option>\n", $id, htmlspecialchars($name));
		}
	}
	if ($group_array) {
		print("<option value=\"0\">--- ޥ롼 ---</option>\n");
		while (list($id, $name) = each($group_array)) {
			if ($group == sprintf("grp-%s", $id)) {
				printf("<option value=\"grp-%s\" selected>%s</option>\n", $id, htmlspecialchars($name));
			} else {
				printf("<option value=\"grp-%s\">%s</option>\n", $id, htmlspecialchars($name));
			}
		}
	}
	print("<option value=\"0\"> ------ </option>\n");
	if ($group == "all") {
		print("<option value=\"all\" selected>٤ɽ</option>\n");
	} else {
		print("<option value=\"all\">٤ɽ</option>\n");
	}
	print("</select>\n");
	print("</td><td align=\"right\">\n");
	print("ɽ<select name=\"new_viewtype\" onChange=\"document.view_form.submit();\">\n");
	while (list($key, $val) = each($sel_array)) 
	{
		if ($viewtype == $key) {
			printf("<option value=\"%s\" selected>%s</option>\n", $key, $val);
		} else {
			printf("<option value=\"%s\">%s</option>\n", $key, $val);
		}
	}
	print("</select>\n");
	print("</td></tr></form></table>\n");
	$db->close();
}


//==============================================================
// Function Name    : Print_ChartLine
//--------------------------------------------------------------
// Note		        : ɽ
//                  :
//==============================================================
Function Print_ChartLine($date, $member_id, $view_type)
{
	global $JJ_DATE_SIEGE, $JJ_USER_ID;

	if ($view_type == VIEWTYPE_WEEK)
	{
		$count = 7;
		list($from_date, $to_date) = Week_ft($date);
	}
	else
	{
		Explode_Date($date, $y, $m, $d);
		$count = Last_date($y, $m);
		list($from_date, $to_date) = Month_ft($date);
	}
	
	// ơ֥̾
	$table_name = sprintf("sche_%s", $member_id);
	
	// ơ֥å
	if (!Tbl_UMUChk($table_name))
	{
		for ($i = 0; $i < $count; $i++)
		{
			print("<td>&nbsp;</td>\n");
		}
		return;
	}

	$db = new DB_Test;
	
	$current_date = $from_date;
	for ($i = 0; $i < $count; $i++)
	{
		$str = sprintf("SELECT * FROM %s", $table_name);
		$str .= sprintf(" WHERE hi = %s%s%s AND public_data = 1", $JJ_DATE_SIEGE, $current_date, $JJ_DATE_SIEGE);
		$str .= " ORDER BY fzi";
		$db->query($str);
		$data_count = $db->nf();
		if ($data_count > 0)
		{
			$img = "";
			while ($db->next_record())
			{
				$schedule_id	= $db->f("schedule_id");
				$fzi			= Time_Format($db->f("fzi"));
				$time 			= TimeFormat2($db->f("fzi"), $db->f("tzi"));
				$data_type_id	= $db->f("data_type_id");
				$data_type		= GetDataType($data_type_id);
				$biko			= $db->f("biko");
				
				if ($member_id != $JJ_USER_ID)
					$link = sprintf("sche_othersdata.php?member_id=%s&schedule_id=%s", $member_id, $schedule_id);
				else
					$link = sprintf("sche_private.php?mode=view&hi=%s&no=%s", $current_date, $schedule_id);
				
				if ($view_type == VIEWTYPE_WEEK)
					$img .= sprintf("%s ", $fzi);
				
				$alt = sprintf("%s %s %s", $time, HTMLF($data_type), HTMLF($biko));
				$img .= sprintf("<a href=\"%s\"><img src=\"%s\" width=\"15\" height=\"15\" alt=\"%s\" border=\"0\"></a><br>", $link, IMG_YOTEI, $alt);
			}
			
			if ($data_count == 1)
				$data_color = GetScheduleColor($data_type_id);
			else
				$data_color = OTHER_SCHEDULE_COLOR;
			
			printf("<td bgcolor=\"%s\" align=\"center\">%s</td>\n", $data_color, $img);
		}
		else
		{
			print("<td>&nbsp;</td>\n");
		}
		$current_date = Next_date($current_date, "D", 1);
	}
	
	$db->close();
}


//==============================================================
// Function Name    : Print_DayChartLine
//--------------------------------------------------------------
// Note		        : ɽɽ
//                  :
//==============================================================
Function Print_DayChartLine($date, $member_id)
{
	global $JJ_USE_DATABASE;
	global $time_array, $color_array;
	
	// ơ֥̾
	$table_name = sprintf("sche_%s", $member_id);
	
	$count = count($time_array);

	// ơ֥å
	if (!Tbl_UMUChk($table_name))
	{
		for ($i = 0; $i < $count; $i++)
		{
			print("<td>&nbsp;</td>\n");
		}
		return;
	}

	$db = new DB_Test;

	for ($i = 0; $i < $count; $i++)
	{
		$str = sprintf("SELECT tzi, data_color FROM %s", $table_name);
		if ($JJ_USE_DATABASE == "jet")
			$str .= sprintf(" WHERE hi = #%s# AND fzi <= '%s' AND tzi > '%s' AND public_data = 1", 
					$date, $time_array[$i] . ":00", $time_array[$i] . ":00");
		else
			$str .= sprintf(" WHERE hi = '%s' AND fzi <= '%s' AND tzi > '%s' AND public_data = 1", 
					$date, $time_array[$i] . ":00", $time_array[$i] . ":00");
		$db->query($str);
		if ($db->nf() > 0)
		{
			$db->next_record();
			$to_time = $db->f("tzi");
			$data_color = $db->f("data_color");
			if ($data_color == "")
				$data_color = 0;
			$span = 1;
			for ($j = $i + 1; $time_array[$j] . ":00" != $to_time; $j++)
			{
				$span++;
			}
			printf("<td colspan=\"%d\" bgcolor=\"%s\">&nbsp;</td>\n",
				$span, $color_array[$data_color]);
			$i += $span - 1;
		}
		else
		{
			print("<td>&nbsp;</td>\n");
		}
	}
	
	$db->close();
}


//==============================================================
// Function Name    : Print_MonthChart
//--------------------------------------------------------------
// Note		        : 롼ɽ
//                  :
//==============================================================
Function Print_MonthChart()
{
	global $hiduke, $sel;
	global $JJ_USER_ID;

	//ռ
	$mv_date_b = Next_date($hiduke, "M", -1);
	$mv_date_a = Next_date($hiduke, "M",  1);
	
	// ʬ
	Explode_Date($hiduke, $yy, $mm, $dd);

	$last_day = Last_date($yy, $mm);	// 
	list ($f_date, $t_date) = Month_ft($hiduke);

	// ơ֥إåɽ
	print("<table width=\"100%\" border=\"1\" cellspacing=\"0\" cellpadding=\"1\">\n");
	printf("<tr><td align=\"center\" colspan=\"%d\" class=\"color01\"><font color=\"white\"><b>\n", 
		$last_day + 1);
	printf("<a href=\"%s?hiduke=%s&sel=%s\"><IMG SRC=\"%s\" border=\"0\" alt=\"\"></a>\n", 
		PG_NAME(), $mv_date_b, $sel, LEFT_GIF);
	printf(" %d ǯ %d  \n", $yy, $mm);
	printf("<a href=\"%s?hiduke=%s&sel=%s\"><IMG SRC=\"%s\" border=\"0\" alt=\"\"></a>\n", 
		PG_NAME(), $mv_date_a, $sel, RIGHT_GIF);
	print("</b></font></td></tr>\n");
	
	printf("<tr class=\"color01\" align=\"center\">\n");
	print("<td>̾/</td>\n");
	$current_date = $f_date;
	for ($i = 0; $i < $last_day; $i++) {
		Explode_Date($current_date, $y, $m, $d);
		$current_date = sprintf("%04d-%02d-%02d", $y, $m, $d);
		Get_Dayoftheweek($current_date, $youbi, $bg_color, $font_color);
		printf("<td width=\"%s\" bgcolor=\"%s\"><font size=\"-2\" color=\"%s\">%d</font></td>\n", 
			MONTH_CHART_WIDTH, $bg_color, $font_color, $d);
		$current_date = Next_date($current_date, "D", 1);
	}
	print("</tr>\n");
	
	// ơ֥ǡɽ
	$db = new DB_Test;
	$db->query(Get_GroupMemberQuery());
	while ($db->next_record()) {
		print("<tr>\n");
		if ($JJ_USER_ID == $db->f("member_id")) {
			$font_color = MY_FONT_COLOR;
		} else {
			$font_color = "black";
		}
//		printf("<td class=\"color02\"><a href=\"%s?member_id=%s&hiduke=%s\" target=\"_parent\"><font color=\"%s\">%s</font></a></td>\n", 
//			 SCHE_MAIN_PG, $db->f("member_id"), $hiduke, $font_color, htmlspecialchars($db->f("member_name")));

		printf("<td class=\"color02\"><font color=\"%s\">%s</font></td>\n", 
			$font_color, HTMLF($db->f("member_name")));

		Print_ChartLine($hiduke, $db->f("member_id"), VIEWTYPE_MONTH);
		print("</tr>\n");
	}
	print("</table>\n");
	$db->close();
}


//==============================================================
// Function Name    : Print_WeekChart
//--------------------------------------------------------------
// Note		        : ɽ
//                  :
//==============================================================
Function Print_WeekChart()
{
	global $hiduke;
	global $JJ_USER_ID;

	// ʬ
	Explode_Date($hiduke, $yy, $mm, $dd);
	
	// ռ
	$mv_date_b = Next_date($hiduke, "D", -7);
	$mv_date_a = Next_date($hiduke, "D",  7);
	
	list ($f_date, $t_date) = Week_ft($hiduke);

	// ơ֥إåɽ
	print("<table width=\"100%\" border=\"1\" cellspacing=\"0\" cellpadding=\"5\" bgcolor=\"white\">\n");
	printf("<tr><td align=\"center\" colspan=\"8\" class=\"color01\"><font color=\"white\"><b>\n");
	printf("<a href=\"%s?hiduke=%s\"><IMG SRC=\"%s\" border=\"0\" alt=\"轵\"></a>\n", 
		PG_NAME(), $mv_date_b, LEFT_GIF);
	printf(" %d ǯ %d  \n", $yy, $mm);
	printf("<a href=\"%s?hiduke=%s\"><IMG SRC=\"%s\" border=\"0\" alt=\"轵\"></a>\n", 
		PG_NAME(), $mv_date_a, RIGHT_GIF);
	print("</b></font></td></tr>\n");
	printf("<tr class=\"color01\">\n");
	print("<td align=\"center\">̾/</td>\n");
	Explode_Date($f_date, $y, $m, $d);
	Explode_Date($t_date, $ty, $tm, $td);
	$current_date = sprintf("%04d-%02d-%02d", $y, $m, $d);
	$to_date = sprintf("%04d-%02d-%02d", $ty, $tm, $td);
	while ($current_date <= $to_date) {
		Get_Dayoftheweek($current_date, $youbi, $bg_color, $font_color);
		printf("<td width=\"%s\" bgcolor=\"%s\" align=\"center\"><font color=\"%s\">%d (%s)</font></td>\n", 
			WEEK_CHART_WIDTH, $bg_color, $font_color, $d, $youbi);
		$current_date = Next_date($current_date, "D", 1);
		Explode_Date($current_date, $y, $m, $d);
		$current_date = sprintf("%04d-%02d-%02d", $y, $m, $d);
	}
	print("</tr>\n");
	
	// ơ֥ǡɽ
	$db = new DB_Test;
	$db->query(Get_GroupMemberQuery());
	while ($db->next_record()) {
		print("<tr>\n");
		if ($JJ_USER_ID == $db->f("member_id")) {
			$font_color = MY_FONT_COLOR;
		} else {
			$font_color = "black";
		}
//		printf("<td class=\"color02\"><a href=\"%s?member_id=%s&hiduke=%s\" target=\"_parent\"><font color=\"%s\">%s</font></a></td>\n", 
//			 SCHE_MAIN_PG, $db->f("member_id"), $hiduke, $font_color, htmlspecialchars($db->f("member_name")));

		printf("<td class=\"color02\"><font color=\"%s\">%s</font></td>\n", 
			$font_color, HTMLF($db->f("member_name")));

		Print_ChartLine($hiduke, $db->f("member_id"), VIEWTYPE_WEEK);
		print("</tr>\n");
	}
	print("</table>\n");
	$db->close();
}


//==============================================================
// Function Name    : Print_DayChart
//--------------------------------------------------------------
// Note		        : ɽ
//                  :
//==============================================================
Function Print_DayChart()
{
	global $hiduke, $group;
	global $JJ_USER_ID;
	
	// ʬ
	Explode_Date($hiduke, $yy, $mm, $dd);
	
	// ռ
	$mv_date_b = Next_date($hiduke,"D",-1);
	$mv_date_a = Next_date($hiduke,"D", 1);

	// ơ֥إåɽ
	print("<table border=\"1\" cellspacing=\"0\" cellpadding=\"5\" width=\"100%\">\n");
	Get_Dayoftheweek($hiduke, $youbi, $bg_color, $font_color);

//	printf("<tr><td align=\"center\" colspan=\"35\" class=\"color01\"><font color=\"white\"><b>\n");
	printf("<tr><td align=\"center\" colspan=\"2\" class=\"color01\"><font color=\"white\"><b>\n");
	printf("<a href=\"%s?hiduke=%s\"><IMG SRC=\"%s\" border=\"0\" alt=\"\"></a>\n", 
		PG_NAME(), $mv_date_b, LEFT_GIF);
	printf(" %d ǯ %d  %d  (%s) \n", $yy, $mm, $dd, $youbi);
	printf("<a href=\"%s?hiduke=%s\"><IMG SRC=\"%s\" border=\"0\" alt=\"\"></a>\n", 
		PG_NAME(), $mv_date_a, RIGHT_GIF);
	print("</b></font></td></tr>\n");
/*
	print("<tr align=\"center\">\n");
	printf("<td class=\"color01\">̾/</td>\n");
	for ($i=7; $i<=23; $i++) {
		if ($i < 12) {	// 
			printf("<td width=\"%s\" colspan=\"2\" bgcolor=\"%s\">%d</td>\n", 
				DAY_CHART_WIDTH, AM_COLOR, $i);
		} else if ($i < 18) {	// 
			printf("<td width=\"%s\" colspan=\"2\" bgcolor=\"%s\">%d</td>\n", 
				DAY_CHART_WIDTH, PM_COLOR, $i);
		} else {	// 
			printf("<td width=\"%s\" colspan=\"2\" bgcolor=\"%s\">%d</td>\n", 
				DAY_CHART_WIDTH, NIGHT_COLOR, $i);
		}
	}
	print("</tr>\n");
*/
	print("<tr align=\"center\" class=\"color01\">\n");
	print("<td width=\"25%\"><b>̾</b></td>\n");
	print("<td width=\"75%\"><b>֡ͽ</b></td>\n");
	print("</tr>\n");
	
	// ơ֥ǡɽ
	$db = new DB_Test;
	$db->query(Get_GroupMemberQuery());
	while ($db->next_record()) 
	{
		print("<tr>\n");
		if ($JJ_USER_ID == $db->f("member_id")) {
			$font_color = MY_FONT_COLOR;
		} else {
			$font_color = "black";
		}
/*
		print("<td class=\"color02\">");
		printf("<a href=\"%s?member_id=%s&hiduke=%s\" target=\"_parent\"><font color=\"%s\">%s</font></a>", 
			 SCHE_MAIN_PG, $db->f("member_id"), $hiduke, $font_color, htmlspecialchars($db->f("member_name")));
		print("</td>\n");
*/		
		printf("<td class=\"color02\"><font color=\"%s\">%s</font></td>\n", 
			$font_color, HTMLF($db->f("member_name")));

		print("<td>\n");
		$schedule_count = Print_TodayData($hiduke, $db->f("member_id"));
		if (!$schedule_count)
			print("&nbsp;");
		print("</td>\n");

		print("</tr>\n");
	}
	print("</table>\n");
	$db->close();
}


//==============================================================
// Function Name    : Program_Start
//--------------------------------------------------------------
// Note		        : 
//                  :
//==============================================================
Login_Start(PG_NAME());

// ǡɤ߹
Get_OptionData($view_type, $f_time, $t_time, $init_public);

// ɽѹ줿饯å¸
if (isset($new_group)) {
	setcookie("group", $new_group);
	$group = $new_group;
} elseif (!isset($group)) {
	$group = "";
}

if (isset($new_viewtype))
	ChangeViewType($new_viewtype);

if (!isset($viewtype))
	$viewtype = $view_type;

// դꤵƤʤкΥǡɽ
if (!isset($hiduke))
	$hiduke = date("Y-m-d");

include("common_printheader.inc");

Print_Menu(1);
print("<table width=\"590\" border=\"0\" cellpadding=\"5\" cellspacing=\"0\">\n");
print("<tr><td bgcolor=\"white\">\n");
Print_ViewChangeForm();

switch ($viewtype) 
{
	case VIEWTYPE_MONTH :	//롼ɽ
		Print_MonthChart();
		break;
	case VIEWTYPE_WEEK :
		Print_WeekChart();
		break;
	default :
		Print_DayChart();
}
print("</td></tr></table>\n");

include("common_printfooter.inc");

?>