<?php
//==============================================================
// Program Name		: workflow_main
// File Name		: workflow_main.php
//--------------------------------------------------------------
// Date             : 2001/02/07
// Author           : Satoshi Fujii
//--------------------------------------------------------------
// Note				: ե
//                  : 
//--------------------------------------------------------------
// Rev.             : 
//                  : 
//==============================================================

require("jetjob.inc");
require("common_login.php");			// 
require("common_menu_change.inc");	// ˥塼
require("common_check.inc");		// 
require("workflow_check.inc");		// λΥåؿ

// ե
define("NEXT_PAGE", 	$JJ_IMG_ROOT . "body" . $JJ_DIR_SEP . "next_page.gif");		// ڡ
define("BACK_PAGE", 	$JJ_IMG_ROOT . "body" . $JJ_DIR_SEP . "back_page.gif");		// ڡ
define("CLIP_IMG",		$JJ_IMG_ROOT . "body" . $JJ_DIR_SEP . "clip.gif");			// źեե
define("RECIEVE_IMG",	$JJ_IMG_ROOT . "body" . $JJ_DIR_SEP . "mail_recieve.gif");	// 
define("SEND_IMG",		$JJ_IMG_ROOT . "body" . $JJ_DIR_SEP . "mail_send.gif");		// 
define("NEW_IMG",		$JJ_IMG_ROOT . "body" . $JJ_DIR_SEP . "new.gif");			// 
define("SET_IMG",		$JJ_IMG_ROOT . "body" . $JJ_DIR_SEP . "set.gif");			// 
define("OK_IMG",		$JJ_IMG_ROOT . "body" . $JJ_DIR_SEP . "wf_ok.gif");			// ǧ
define("NG_IMG",		$JJ_IMG_ROOT . "body" . $JJ_DIR_SEP . "wf_ng.gif");			// 
define("ING_IMG",		$JJ_IMG_ROOT . "body" . $JJ_DIR_SEP . "wf_ing.gif");		// 
define("CANCEL_IMG", 	$JJ_IMG_ROOT . "body" . $JJ_DIR_SEP . "wf_can.gif");
define("SPACE_GIF_FILE",$JJ_IMG_ROOT . "spacer.gif");	// 

// طʿ
define("BG_COLOR_1", "#cccccc");
define("BG_COLOR_4", "#f7f2e8");

define("PAGE_WIDTH", 700);							// ڡ
define("CSS_FILE", $JJ_CSS_ROOT . $JJ_CSS_NAME);	// 륷
define("FILE_DIR_NAME", $JJ_WORKFLOW_ROOT);			// źեե¸
define("MEMBER_TBL", "common_member");				// Сơ֥
define("DATA_TBL", "workflow_data");				// ǡơ֥̾
define("TYPE_TBL", "workflow_type");				// ơ֥̾
define("ROUTE_TBL", "workflow_route");				// ϩơ֥̾
define("SAVE_ROUTE_TBL", "workflow_save_route");	// ¸ϩơ֥̾


$mode_array = array("ʸ", "ʸ", "");
$icon_array = array(RECIEVE_IMG, SEND_IMG, NEW_IMG);

$status_array = array("", "ǧ", "ǧ", "ä");
$status_icon_array = array(ING_IMG, OK_IMG, NG_IMG, CANCEL_IMG);


//==============================================================
// Function Name    : Get_MemberName
//--------------------------------------------------------------
// Note		        : 
//                  :
//==============================================================
Function Get_MemberName($member_id)
{
	$db = new DB_Test;
	$query = sprintf("SELECT * FROM %s WHERE member_id = '%s'", MEMBER_TBL, $member_id);
	$db->query($query);
	$db->next_record();
	$ret = $db->f("member_name");
	$db->close();
	
	return $ret;
}


//==============================================================
// Function Name    : Get_TypeName
//--------------------------------------------------------------
// Note		        : 
//                  :
//==============================================================
Function Get_TypeName($type_id)
{
	$db = new DB_Test;
	$query = sprintf("SELECT * FROM %s WHERE type_id = '%s'", TYPE_TBL, $type_id);
	$db->query($query);
	if ($db->nf() > 0) {
		$db->next_record();
		$ret = $db->f("type_name");
	} else {
		$ret = "ʤ";
	}
	$db->close();
	
	return $ret;
}


//==============================================================
// Function Name    : Check_CurrentMember
//--------------------------------------------------------------
// Note		        : 
//                  :
//==============================================================
Function Check_CurrentMember($data_id, $member_id)
{
	$ret = FALSE;
	
	$db = new DB_Test;
	$query = sprintf("SELECT receive_flg FROM %s", ROUTE_TBL);
	$query .= sprintf(" WHERE data_id = '%s' AND member_id = '%s'", $data_id, $member_id);
	$db->query($query);
	if ($db->nf() > 0) {
		$db->next_record();
		if ($db->f("receive_flg") == 1)
			$ret = TRUE;
	}
	
	return $ret;
}


//==============================================================
// Function Name    : Get_RouteMember
//--------------------------------------------------------------
// Note		        : ϩΥСɣĤͤˤ֤
//                  :
//==============================================================
Function Get_RouteMember($data_id)
{
	$db = new DB_Test;
	
	$query = sprintf("SELECT member_id, biko FROM %s WHERE data_id = '%s' ORDER BY route_no", 
				ROUTE_TBL, $data_id);
	$db->query($query);
	$ret = array();
	while ($db->next_record()) {
		$ret[$db->f("member_id")] = $db->f("biko");
	}
	
	$db->close();
	
	return $ret;
}


//==============================================================
// Function Name    : Get_SaveRoute
//--------------------------------------------------------------
// Note		        : ¸ϩμ
//                  : ʼʬϤϤ
//==============================================================
Function Get_SaveRoute($save_route_id)
{
	global $JJ_USER_ID;
	
	// ϩ
	$db = new DB_Test;
	$query = sprintf("SELECT * FROM %s WHERE save_route_id = '%s'", 
				SAVE_ROUTE_TBL, $save_route_id);
	$db->query($query);
	$db->next_record();
	$ret = $db->f("save_route");
	$db->close();
	
	// 
	$ret_no = explode(",", $ret);
//Ver4ʹ	array_pop($ret);
	
	// ʬޤޤƤ
	$x=1;
	for ($i = 0; $i < count($ret_no); $i++) {
		$ret = explode("-", $ret_no[$i]);
		if ($ret_no[$i]){
//			if (($ret[$i] != $JJ_USER_ID) || (!$ret[$i]))
			if (($ret[1] != $JJ_USER_ID) || (!$ret[1])){
//				$ret2[] = $ret[$i];
				$ret2[] = $x . "-" . $ret[1];
				$x++;
			}
		}
	}
	$ret2[] = "";
	
	return $ret2;
}


//==============================================================
// Function Name    : Get_TemplateName
//--------------------------------------------------------------
// Note		        : 
//                  :
//==============================================================
Function Get_TemplateList(&$id_list, &$name_list)
{
	$db = new DB_Test;
	
	$query = sprintf("SELECT * FROM workflow_template ORDER BY template_id");
	$db->query($query);
	while ($db->next_record()) {
		$id_list[] = $db->f("template_id");
		$name_list[] = $db->f("template_name");
	}
	$db->close();
}


//==============================================================
// Function Name    : Format_Date
//--------------------------------------------------------------
// Note		        : 
//                  :
//==============================================================
Function Format_Date($pgDate)
{
	global $JJ_DATETIME_SEP;
	
	$buffer = explode($JJ_DATETIME_SEP, $pgDate);
	
	$year = $buffer[0];
	$month = $buffer[1];
//	$day = $buffer[2];
	$day = explode(" ", $buffer[2]);
	
	return sprintf("%04dǯ %d %d", $year, $month, $day[0]);
}


//==============================================================
// Function Name    : Data_Insert
//--------------------------------------------------------------
// Note		        : 
//                  :
//==============================================================
Function Data_Insert()
{
	global $title, $type_id, $body, $biko, $file_name, $route_members;
	global $JJ_USER_ID;
	global $JJ_USERNAME;

	if (!$file_name)
		$file_name = "0";
	if (!$biko)
		$biko = "0";
	else
		$biko = str_kigouchk($biko);

	$title = str_kigouchk($title);

	// ʸѴ
	$member_array = explode(",", $route_members);

	// ʸϤե¸
	$body_path = Body_Save($body);
	
	// դ
	$date = date("Y-m-d");

	$db = new DB_Test;

	// ǡɣĤμ
	$data_id = uniqid("") . $JJ_USERNAME;
	
	// ϩ¸
	$min_no = 9999;
	while (list($key, $val) = each($member_array)) {
		if (!$member_array[$key])
			continue;
		
		// 롼IDμ
		$route_id = uniqid("") . $JJ_USERNAME;
		
		// ȥСɣĤʬ
		$tmp = explode("-", $member_array[$key]);
		$route_no = $tmp[0];
		$member_id = $tmp[1];
		
		// Ǿθ
		if ($min_no > $route_no)
			$min_no = $route_no;
		
		$query = sprintf("INSERT INTO %s VALUES('%s', '%s', %d, '%s', 0, '%s', NULL)", 
					ROUTE_TBL, $route_id, $data_id, $route_no, $member_id, $date);
		$db->query($query);
	}
	
	// ǽηϩ
	$query = sprintf("UPDATE %s SET receive_flg = 1 WHERE data_id = '%s' AND route_no = %d",
				ROUTE_TBL, $data_id, $min_no);
	$db->query($query);
	
	// ǡ¸
	$query = sprintf("INSERT INTO %s VALUES('%s', '%s', 'dummy', 0, '%s', '%s', '%s', 0, '%s', '%s', '%s', '%s')", 
		DATA_TBL, $data_id, $type_id, $JJ_USER_ID,
		$date, $date, $title, str_kigouchk($body_path), $file_name, $biko);
	$db->query($query);

	$db->close();
}


//==============================================================
// Function Name    : Data_Complete
//--------------------------------------------------------------
// Note		        : λ
//                  :
//==============================================================
Function Data_Complete($data_id)
{
	$date = date("Y-m-d");
	
	$db = new DB_Test;
	$query = sprintf("UPDATE %s SET status_no = 1, complete_date = '%s' WHERE data_id = '%s'",
				DATA_TBL, $date, $data_id);
	$db->query($query);
	$db->close();
}


//==============================================================
// Function Name    : Approval
//--------------------------------------------------------------
// Note		        : ǧ
//                  :
//==============================================================
Function Approval($data_id, $biko)
{
	global $JJ_USER_ID;
		
	// ռ
	$date = date("Y-m-d");

	if (!$biko)
		$biko = "Null";
	else
		$biko = sprintf("'%s'", str_kigouchk($biko));

	$db = new DB_Test;
	
	// μ
	$query = sprintf("SELECT route_no FROM %s WHERE data_id = '%s' AND member_id = '%s'",
				ROUTE_TBL, $data_id, $JJ_USER_ID);
	$db->query($query);
	$db->next_record();
	$route_no = $db->f("route_no");
	
	// ηϩ򸡺
	$query = sprintf("SELECT route_no FROM %s", ROUTE_TBL);
	$query .= sprintf(" WHERE route_no > %d AND data_id = '%s'", $route_no, $data_id);
	$db->query($query);
	if ($db->nf() > 0) {
		$next_route_no = 9999;
		while ($db->next_record()) {
			if ($next_route_no > $db->f("route_no"))
				$next_route_no = $db->f("route_no");
		}
		$query = sprintf("UPDATE %s SET receive_flg = 1, receive_date = '%s'", ROUTE_TBL, $date);
		$query .= sprintf(" WHERE data_id = '%s' AND route_no = %d", $data_id, $next_route_no);
		$db->query($query);
	} else {	// λ
		Data_Complete($data_id);
	}

	// ͤν
	$query = sprintf("UPDATE %s SET receive_flg = 2, biko = %s WHERE data_id = '%s' AND member_id = '%s'", 
				ROUTE_TBL, $biko, $data_id, $JJ_USER_ID);
	$db->query($query);
	$query = sprintf("UPDATE %s SET receive_flg = 2", ROUTE_TBL);
	$query .= sprintf(" WHERE data_id = '%s' AND route_no = %d", $data_id, $route_no);
	$db->query($query);
	
	$db->close();
}


//==============================================================
// Function Name    : Denial
//--------------------------------------------------------------
// Note		        : ǧ
//                  :
//==============================================================
Function Denial($data_id, $biko)
{
	global $JJ_USER_ID;
	
	$date = date("Y-m-d");

	if (!$biko)
		$biko = "Null";
	else
		$biko = sprintf("'%s'", str_kigouchk($biko));

	$db = new DB_Test;
	
	// μ
	$query = sprintf("SELECT route_no FROM %s", ROUTE_TBL);
	$query .= sprintf(" WHERE data_id = '%s' AND member_id = '%s'", $data_id, $JJ_USER_ID);
	$db->query($query);
	$db->next_record();
	$route_no = $db->f("route_no");
	
	// ǡ
	$query = sprintf("UPDATE %s SET status_no = 2, complete_date = '%s' WHERE data_id = '%s'",
				DATA_TBL, $date, $data_id);
	$db->query($query);
	
	// ͤν
	$query = sprintf("UPDATE %s SET biko = %s WHERE data_id = '%s' AND member_id = '%s'", 
				ROUTE_TBL, $biko, $data_id, $JJ_USER_ID);
	$db->query($query);

	// ե饰
	$query = sprintf("UPDATE %s SET receive_flg = 2", ROUTE_TBL);
	$query .= sprintf(" WHERE data_id = '%s' AND route_no = %d", $data_id, $route_no);
	$db->query($query);

	$db->close();
}


//==============================================================
// Function Name    : Cancel
//--------------------------------------------------------------
// Note		        : 󥻥
//                  :
//==============================================================
Function Cancel($data_id)
{
	// դμ
	$date = date("Y-m-d");
	
	$db = new DB_Test;
	
	// ǡ
	$query = sprintf("UPDATE %s SET status_no = 3, complete_date = '%s', complete_read_flg = 1 WHERE data_id = '%s'",
				DATA_TBL, $date, $data_id);
	$db->query($query);
	
	// ϩ
	$query = sprintf("UPDATE %s SET receive_flg = 2", ROUTE_TBL);
	$query .= sprintf(" WHERE data_id = '%s' AND receive_flg = 1", $data_id);
	$db->query($query);
	
	$db->close();
}


//==============================================================
// Function Name    : Check_CompleteData
//--------------------------------------------------------------
// Note		        : λǡ뤫
//                  :
//==============================================================
Function Check_CompleteData($data_id = "")
{
	global $JJ_USER_ID;
	
	$ret = false;
	$db = new DB_Test;
	if ($data_id)
		$query = sprintf("SELECT * FROM %s WHERE data_id = '%s'",
					DATA_TBL, $data_id);
	else
		$query = sprintf("SELECT * FROM %s WHERE from_member_id = '%s'",
					DATA_TBL, $JJ_USER_ID);
	$db->query($query);
	while ($db->next_record()) {
		if ($db->f("status_no") && !$db->f("complete_read_flg")) {
			$ret = true;
			break;
		}
	}
	$db->close();
	
	return $ret;
}


//==============================================================
// Function Name    : Read_CompleteData
//--------------------------------------------------------------
// Note		        : λǧδɽ
//                  :
//==============================================================
Function Read_CompleteData($data_id)
{
	$db = new DB_Test;
	$query = sprintf("UPDATE %s SET complete_read_flg = 1 WHERE data_id = '%s'",
				DATA_TBL, $data_id);
	$db->query($query);
	$db->close();
}


//==============================================================
// Function Name    : Body_Save
//--------------------------------------------------------------
// Note		        : Ƥ¸
//                  :
//==============================================================
Function Body_Save($body)
{
	global $dir_path;
	
	$file_path = tempnam($dir_path, "workflow_");

	$fp = fopen($file_path, "w");
	fwrite($fp, $body);
	fclose($fp);
	
	chmod($file_path, 0755);
	
	return $file_path;
}


//==============================================================
// Function Name    : File_Save
//--------------------------------------------------------------
// Note		        : źեե¸
//                  :
//==============================================================
Function File_Save($dir_path)
{
	global $file, $file_name, $file_size, $file_type;
	
	if ($file && $file_name && $file_size) {
		$kakutyousi = explode(".", $file_name);
		$folder_path = tempnam($dir_path, "workflow_attach_") . "." . "$kakutyousi[1]";
		$file_name = basename(strtr(strtr($folder_path, ":\\", "/"), "\\", "/"));
		copy($file, $folder_path);
	} else {
		Error("եΥåץɤ˼Ԥޤ");
	}
}


//==============================================================
// Function Name    : Dir_Check
//--------------------------------------------------------------
// Note		        : ǥ쥯ȥΥå
//                  :
//==============================================================
Function Dir_Check($dir_path)
{
	if (!file_exists($dir_path)) {
		if (!@mkdir($dir_path, 0777))
			Error("ǥ쥯ȥ " . $dir_path . " κ˼Ԥޤ");
	}
}


//==============================================================
// Function Name    : Search_Array
//--------------------------------------------------------------
// Note		        : $array󤫤$strʸθ
//                  :
//==============================================================
Function Search_Array($str, $array)
{
	if (is_array($array)) {
		for ($i = 0; $i < count($array); $i++) {
			if ($array[$i] == $str)
				return true;
		}
	}
	return false;
}


//==============================================================
// Function Name    : Read_Template
//--------------------------------------------------------------
// Note		        : ƥץ졼ȥեɤ߹
//                  :
//==============================================================
Function Read_Template($template_id)
{
	if (!$template_id)
		return;
	
	$db = new DB_Test;
	$query = sprintf("SELECT * FROM workflow_template WHERE template_id = '%s'", $template_id);
	$db->query($query);
	$db->next_record();
	$path = $db->f("template_path");
	
	$fp = fopen($path, "r");
	$ret = fread($fp, 1000000);
	fclose($fp);
	
	return $ret;
}


//==============================================================
// Function Name    : Print_Header
//--------------------------------------------------------------
// Note		        : 
//                  :
//==============================================================
Function Print_Header()
{
	global $JJ_USERNAME, $JJ_OUTPUT_CHARSET;
	global $mode;

	print("<HTML>\n");
	print("<HEAD>\n");
	print("<META http-equiv=\"Content-Type\" content=\"text/html; charset=$JJ_OUTPUT_CHARSET\">\n");
	printf("<LINK REL=STYLESHEET TYPE=\"text/css\" HREF=\"%s\">\n", CSS_FILE);
	print("</HEAD>\n");
	if (Get_CompleteCount() && $mode != "view") {
		print("<BODY onload=\"alert('λޤ');\">\n");
		$mode = 1;
	} else {
		print("<BODY>\n");
	}
}


//==============================================================
// Function Name    : Print_Menu
//--------------------------------------------------------------
// Note		        : 
//                  :
//==============================================================
Function Print_Menu($current_mode)
{
	global $mode_array, $icon_array;
	
	printf("<table width=\"%d\" border=\"0\" cellpadding=\"5\" cellspacing=\"0\">\n", PAGE_WIDTH);
	print("<tr align=\"center\">\n");
	for ($i = 0; $i < count($mode_array); $i++) {
		if ($i == $current_mode && $current_mode != "view") {
			printf("<td nowrap class=\"color00\" valign=\"middle\" width=\"25%%\">");
			printf("<a href=\"%s?mode=%d\"><img src=\"%s\" border=\"0\" hspace=\"5\" align=\"absmiddle\"><font color=\"white\"><b>%s</b></font></a>", 
				PG_NAME(), $i, $icon_array[$i], $mode_array[$i]);
			print("</td>\n");
		} else {
			printf("<td bgcolor=\"%s\" valign=\"middle\" width=\"25%%\">", BG_COLOR_1);
			printf("<a href=\"%s?mode=%d\"><img src=\"%s\" border=\"0\" hspace=\"5\" align=\"absmiddle\"> %s</a></td>\n", 
				PG_NAME(), $i, $icon_array[$i], $mode_array[$i]);
		}
	}
	print("</tr>\n");
	printf("<tr><td nowrap class=\"color00\" colspan=\"%d\"><img height=\"1\" width=\"1\" src=\"%s\"></td></tr>\n", count($mode_array), SPACE_GIF_FILE);
	print("</table>\n");
}


//==============================================================
// Function Name    : Sort_ViewForm
//--------------------------------------------------------------
// Note		        : ɽڤؤեɽ
//                  :
//==============================================================
Function Sort_ViewForm($order, $mode = "")
{
	$status_u_sel = "";
	$status_d_sel = "";
	$type_u_sel = "";
	$type_d_sel = "";
	$title_u_sel = "";
	$title_d_sel = "";
	$member_u_sel = "";
	$member_d_sel = "";
	$date_u_sel = "";
	$date_d_sel = "";
	$file_u_sel = "";
	$file_d_sel = "";
	switch ($order) {
		case "status_u" :	$status_u_sel = "SELECTED";	break;
		case "status_d" :	$status_d_sel = "SELECTED";	break;
		case "type_u" :		$type_u_sel = "SELECTED";	break;
		case "type_d" :		$type_d_sel = "SELECTED";	break;
		case "title_u" :	$title_u_sel = "SELECTED";	break;
		case "title_d" :	$title_d_sel = "SELECTED";	break;
		case "member_u" :	$member_u_sel = "SELECTED";	break;
		case "member_d" :	$member_d_sel = "SELECTED";	break;
		case "date_u" :		$date_u_sel = "SELECTED";	break;
		case "date_d" :		$date_d_sel = "SELECTED";	break;
		case "file_u" :		$file_u_sel = "SELECTED";	break;
		case "file_d" :		$file_d_sel = "SELECTED";	break;
		default       :		$date_d_sel = "SELECTED";	break;
	}

	print("<table width=\"100%\" cellpadding=\"5\" cellspacing=\"0\"><tr>\n");
	printf("<form action=\"%s\" method=\"post\" name=\"form2\">\n", PG_NAME());
	print("<input type=\"hidden\" name=\"mode\" value=\"$mode\">\n");
	print("<td>¤ؤ<select name=order onChange=\"document.form2.submit();\">\n");
	if (empty($mode)){
		print("<option value=\"status_u\" $status_u_sel>֡碬</option>");
		print("<option value=\"status_d\" $status_d_sel>߽֡碭</option>");
		print("<option value=\"type_u\" $type_u_sel>ࡡ碬</option>");
		print("<option value=\"type_d\" $type_d_sel>ࡡ߽碭</option>");
		print("<option value=\"title_u\" $title_u_sel>ȥ롡碬</option>");
		print("<option value=\"title_d\" $title_d_sel>ȥ롡߽碭</option>");
		print("<option value=\"member_u\" $member_u_sel>ԡ碬</option>");
		print("<option value=\"member_d\" $member_d_sel>ԡ߽碭</option>");
		print("<option value=\"date_u\" $date_u_sel>碬</option>");
		print("<option value=\"date_d\" $date_d_sel>߽碭</option>");
		print("<option value=\"file_u\" $file_u_sel>źա碬</option>");
		print("<option value=\"file_d\" $file_d_sel>źա߽碭</option>");
	}else{
		print("<option value=\"status_u\" $status_u_sel>֡碬</option>");
		print("<option value=\"status_d\" $status_d_sel>߽֡碭</option>");
		print("<option value=\"type_u\" $type_u_sel>ࡡ碬</option>");
		print("<option value=\"type_d\" $type_d_sel>ࡡ߽碭</option>");
		print("<option value=\"title_u\" $title_u_sel>ȥ롡碬</option>");
		print("<option value=\"title_d\" $title_d_sel>ȥ롡߽碭</option>");
		print("<option value=\"date_u\" $date_u_sel>碬</option>");
		print("<option value=\"date_d\" $date_d_sel>߽碭</option>");
		print("<option value=\"file_u\" $file_u_sel>źա碬</option>");
		print("<option value=\"file_d\" $file_d_sel>źա߽碭</option>");
	}
	print("</select></td>\n");
	print("</form></tr></table>\n");
}


//==============================================================
// Function Name    : Print_ViewCountForm
//--------------------------------------------------------------
// Note		        : ɽڤؤեɽ
//                  :
//==============================================================
Function Print_ViewCountForm($mode = "")
{
	global $view_count_list, $view_count;
	
	print("<table width=\"100%\" cellpadding=\"5\" cellspacing=\"0\"><tr>\n");
	printf("<form action=\"%s\" method=\"post\" name=\"form1\">\n", PG_NAME());
	print("<input type=\"hidden\" name=\"mode\" value=\"$mode\">\n");
	print("<td align=\"right\">\n");
	print("ɽ<select name=new_view_count onChange=\"document.form1.submit();\">\n");
	for ($i=0; $i<count($view_count_list); $i++) 
	{
		if ($view_count_list[$i] == $view_count) {
			print("<option value=\"$view_count_list[$i]\" selected>$view_count_list[$i] </option>");
		} else {
			print("<option value=\"$view_count_list[$i]\">$view_count_list[$i] </option>\n");
		}
	}
	print("</select></td>\n");
	print("</form></tr></table>\n");
}


//==============================================================
// Function Name    : Print_RouteInputForm
//--------------------------------------------------------------
// Note		        : 
//                  :
//==============================================================
Function Print_RouteInputForm($section_id = "", $route_members = "")
{
	global $JJ_USER_ID;
	global $save_route_id;
	
// Javaץȵ
?>
<script language="JavaScript">
<!--
function add_member(form) {
	if (form.member_id.selectedIndex == -1) {
		return;
	}
	var count = form.group_member_id.options.length;
	var dummy_text = form.group_member_id.options[count - 1].text;
	var dummy_value = form.group_member_id.options[count - 1].value;
	var select_no = form.member_id.selectedIndex;
	var select_text = form.member_id.options[select_no].text;
	var select_value = form.member_id.options[select_no].value;
	var no_index = form.no.selectedIndex;
	select_value = form.no.options[no_index].value + '-' + select_value;
	select_text = form.no.options[no_index].text + '-' + select_text;
	
	form.group_member_id.options[count - 1] = new Option(select_text, select_value);
	form.group_member_id.options[count] = new Option(dummy_text, dummy_value);
	form.member_id.options[select_no] = null;
	
	var no_count = form.no.options.length;
	var no_value = form.no.options[no_index].value;
	var new_value = parseInt(no_value) + 1;
	if (form.no.options[no_index].value == form.no.options[no_count - 1].value) {
		form.no.options[no_count] = new Option(new_value, new_value);
		form.no.selectedIndex = no_count;
	} else {
		form.no.selectedIndex = no_count - 1;
	}
	
}

function remove_member(form) {
	if (form.group_member_id.selectedIndex == -1) {
		return;
	}
	var count = form.member_id.options.length;
	var dummy_text = form.member_id.options[count - 1].text;
	var dummy_value = form.member_id.options[count - 1].value;
	var len = form.group_member_id.length;
	var select_no = form.group_member_id.selectedIndex;
	var select_text = form.group_member_id.options[select_no].text;
	var select_value = form.group_member_id.options[select_no].value;
	
	tmp = select_text.split('-');
	select_text = tmp[1];
	tmp = select_value.split('-');
	select_value = tmp[1];
	
	if (len < 2 || select_no == len - 1) {
		return;
	}
	form.group_member_id.options[select_no] = null;
	form.member_id.options[count - 1] = new Option(select_text, select_value);
	form.member_id.options[count] = new Option(dummy_text, dummy_value);
}

function set_route_members(form) {
	var len = form.group_member_id.length;
	for (i = 0; i < len - 1; i++) {
		form.route_members.value += form.group_member_id.options[i].value + ",";
	}
	form.submit();
}
//-->
</script>
<?php

	$db = new DB_Test;
	
	// °μ
	if ($section_id == "") {
		$query = sprintf("SELECT section_id FROM %s", MEMBER_TBL);
		$query .= sprintf(" WHERE member_id = '%s'", $JJ_USER_ID);
		$db->query($query);
		$db->next_record();
		$section_id = "SEC-" . $db->f("section_id");
	}

	// С
	$member_id = array();
	$member_name = array();
	$tmp = explode("-", $section_id);
	if (($tmp[0] == "SEC") || ($section_id == "0"))
	{
		$query_str = "SELECT * FROM common_member";
		if ($tmp[0] == "SEC"){
			if ($tmp[1]){
				$query_str .= sprintf(" WHERE section_id = '%s'", $tmp[1]);
			}
		}
		$query_str .= " ORDER BY furigana";
		$db->query($query_str);
		if ($db->nf() > 0)
		{
			while ($db->next_record()) 
			{
				if ($JJ_USER_ID != $db->f("member_id")) {
					$member_id[] = $db->f("member_id");
					$member_name[] = $db->f("member_name");
				}
			}
		}
		else
		{
			$member_id = array();
			$member_name = array();
		}
	}
	else
	{
		if ($tmp[0] == "GRP")
		{
			$query_str = sprintf("SELECT common_group_member.member_id, common_member.member_name FROM common_group_member, common_member WHERE common_group_member.member_id = common_member.member_id AND group_id = '%s' ORDER BY furigana",
										 $tmp[1]);
			$db->query($query_str);
			if ($db->nf() > 0)
			{
				while ($db->next_record()) 
				{
					if ($JJ_USER_ID != $db->f("member_id")) {
						$member_id[] = $db->f("member_id");
						$member_name[] = $db->f("member_name");
					}
				}
			}
			else
			{
				$member_id = array();
				$member_name = array();
			}
		}
		else
		{
			$member_id = array();
			$member_name = array();
		}
	}
	
	// °
	$query_str = "SELECT * FROM common_section ORDER BY section_id";
	$db->query($query_str);
	while ($db->next_record()) {
		$section_id_array[] = $db->f("section_id");
		$section_name_array[] = $db->f("section_name");
	}
	
	// ޥ롼׼
	$query_str = sprintf("SELECT * FROM common_group WHERE (member_id = '%s') OR (common_flg <> '') ORDER BY group_id", 
					$JJ_USER_ID);
	$db->query($query_str);
	if ($db->nf() > 0)
	{
		while ($db->next_record()) 
		{
			$group_id_array[] = $db->f("group_id");
			$group_name_array[] = $db->f("group_name");
		}
	}
	else
	{
		$group_id_array = array();
		$group_name_array = array();
	}
	
	print("<table>\n");
	
	print("<tr><td colspan=\"3\">\n");
	print("<select name=\"save_route_id\" onchange=\"this.form.mode.value='2';this.form.submit();\">\n");
	print("<option value=\"0\">-- ¸ϩ --</option>\n");
	$query_str = sprintf("SELECT * FROM %s ORDER BY save_route_id", SAVE_ROUTE_TBL);
	$db->query($query_str);
	if (!isset($save_route_id))	$save_route_id="";
	while ($db->next_record()) {
		if ($save_route_id == $db->f("save_route_id"))
			printf("<option value=\"%s\" selected>%s</option>\n",
				$db->f("save_route_id"), $db->f("save_route_name"));
		else
			printf("<option value=\"%s\">%s</option>\n",
				$db->f("save_route_id"), $db->f("save_route_name"));
	}
	print("</select>\n");
	print("</td></tr>\n");
	
	print("<tr>\n");
	if (!isset($save_route_id))	$save_route_id="";
	if ($save_route_id)
		$route_member_id = Get_SaveRoute($save_route_id);
	else
		$route_member_id = explode(",", $route_members);
	print("<td>ϩ<br><select size=\"10\" name=\"group_member_id\">\n");
	for ($i=0; $i<count($route_member_id) && ($route_member_id[$i] != ""); $i++) {
		$tmp = explode("-", $route_member_id[$i]);
		$id = $tmp[1];
		if ($route_member_id[$i])
			printf("<option value=\"%s\">%s-%s</option>\n", 
				$route_member_id[$i], $tmp[0], Get_MemberName($id));
	}
	print("<option value=\"\"></option>\n");
	print("</select></td>\n");
	
	print("<td align=\"center\">\n");
	print("<select name=\"no\">\n");
	for ($i=1; $i<=count($route_member_id); $i++) {
		printf("<option value=\"%d\">%d</option>\n", $i, $i);
	}
	print("</select>\n");
	print("<br>\n");
	print("<input type=\"button\" value=\"ɲ\" onClick=\"add_member(this.form);\">\n");
	print("<br><br>\n");
	print("<input type=\"button\" value=\"\" onClick=\"remove_member(this.form);\">\n");
	print("</td>\n");
	
	print("<td>\n");
	print("<select name=\"section_id\" onchange=\"this.form.mode.value='2';set_route_members(this.form);\">\n");
	print("<option value=\"0\">٤ɽ</option>\n");
	print("<option value=\"\">ݡݡݽꡡ°ݡݡ</option>\n");
	if ($section_id != "0"){
		$tmp = explode("-", $section_id);
	}else{
		$tmp = array("","");
	}
	for ($i=0; $i<count($section_id_array); $i++) {
		if (($tmp[1] == $section_id_array[$i]) && ($tmp[0] == "SEC"))
			printf("<option value=\"%s\" selected>%s</option>\n", "SEC-" . $section_id_array[$i], $section_name_array[$i]);
		else
			printf("<option value=\"%s\">%s</option>\n", "SEC-" . $section_id_array[$i], $section_name_array[$i]);
	}
	print("<option value=\"\">ݥޥ롼סݡ</option>\n");
	for ($i=0; $i<count($group_id_array); $i++) {
		if (($tmp[1] == $group_id_array[$i]) && ($tmp[0] == "GRP"))
			printf("<option value=\"%s\" SELECTED>%s</option>\n", "GRP-" . $group_id_array[$i], $group_name_array[$i]);
		else
			printf("<option value=\"%s\">%s</option>\n", "GRP-" . $group_id_array[$i], $group_name_array[$i]);
	}
	print("</select><br>\n");
	print("<select size=\"10\" name=\"member_id\">\n");
	for ($i=0; $i<count($member_id); $i++) {
		if (Search_Array($member_id[$i], $route_member_id) == false)
			printf("<option value=\"%s\">%s</option>\n", $member_id[$i], $member_name[$i]);
	}
	print("<option value=\"\"></option>");
	print("</select></td>\n");
	print("</tr>\n");

	print("</table>\n");
	
	$db->close();
}


//==============================================================
// Function Name    : Print_PageMove
//--------------------------------------------------------------
// Note		        : ڡưɽ
//                  :
//==============================================================
Function Print_PageMove($start_row, $end_row, $count)
{
	global $page, $mode, $order;
	
	print("<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\"><tr>\n");

	// ڡܥ
	if ($start_row != 0) {
		print("<td align=\"center\" width=\"50%\">\n");
		printf("<a href=\"%s?mode=%d&page=%d&order=%s\"><IMG SRC=\"%s\" BORDER=\"0\"></a></td>\n"
				, PG_NAME(), $mode, $page - 1, $order, BACK_PAGE);
	} else {
		print("<td align=\"center\" width=\"50%\"><BR></td>\n");
	}
	
	// ڡܥ
	if ($count > $end_row) {
		print("<td align=\"center\" width=\"50%\">\n");
		printf("<a href=\"%s?mode=%d&page=%d&order=%s\"><IMG SRC=\"%s\" BORDER=\"0\"></a></td>\n"
				, PG_NAME(), $mode, $page + 1, $order, NEXT_PAGE);
	} else {
		print("<td align=\"center\" width=\"50%\"><BR></td>\n");
	}
	
	print("</tr></table>\n");
}


//==============================================================
// Function Name    : Print_ReceiveIndexPage
//--------------------------------------------------------------
// Note		        : 
//                  :
//==============================================================
Function Print_ReceiveIndexPage ()
{
	global $page, $view_count;
	global $JJ_USE_DATABASE, $JJ_USER_ID;
	global $status_array, $status_icon_array;
	global $order;

	$db = new DB_Test;
	
	// դνϷѹ
	if ($JJ_USE_DATABASE == "postgres")
		$db->query("set datestyle to 'ISO'");
	
	printf("<table border=\"0\" bgcolor=\"white\" cellpadding=\"5\" cellspacing=\"0\" width=\"%d\">\n", PAGE_WIDTH);
	print("<tr>\n");
	print("<td>\n");

	print("<table border=\"0\" cellpadding=\"5\" cellspacing=\"2\" width=\"100%\">\n");
	
	print("<tr><td colspan=\"3\">\n");
	Sort_ViewForm($order);
	print("</td><td colspan=\"3\" align=\"right\">\n");
	Print_ViewCountForm();
	print("</td></tr>\n");
	
	// 
	switch ($order) {
		case "status_u" :
			$order_str = sprintf(" ORDER BY %s.status_no", DATA_TBL);
			break;
		case "type_u" :
			$order_str = sprintf(" ORDER BY %s.type_id", DATA_TBL);
			break;
		case "title_u" :
			$order_str = sprintf(" ORDER BY %s.data_title", DATA_TBL);
			break;
		case "member_u" :
			$order_str = sprintf(" ORDER BY %s.from_member_id", DATA_TBL);
			break;
		case "date_u" :
			$order_str = sprintf(" ORDER BY %s.receive_date", ROUTE_TBL);
			break;
		case "file_u" :
			$order_str = sprintf(" ORDER BY %s.attach_file_path", DATA_TBL);
			break;
		case "status_d" :
			$order_str = sprintf(" ORDER BY %s.status_no DESC", DATA_TBL);
			break;
		case "type_d" :
			$order_str = sprintf(" ORDER BY %s.type_id DESC", DATA_TBL);
			break;
		case "title_d" :
			$order_str = sprintf(" ORDER BY %s.data_title DESC", DATA_TBL);
			break;
		case "member_d" :
			$order_str = sprintf(" ORDER BY %s.from_member_id DESC", DATA_TBL);
			break;
		case "date_d" :
			$order_str = sprintf(" ORDER BY %s.receive_date DESC", ROUTE_TBL);
			break;
		case "file_d" :
			$order_str = sprintf(" ORDER BY %s.attach_file_path DESC", DATA_TBL);
			break;
		default :
			$order_str = sprintf(" ORDER BY %s.data_id DESC", DATA_TBL);
	}
	
	$query = sprintf("SELECT %s.*, %s.* FROM %s, %s", 
				DATA_TBL, ROUTE_TBL, DATA_TBL, ROUTE_TBL);
	$query .= sprintf(" WHERE %s.member_id = '%s'", ROUTE_TBL, $JJ_USER_ID);
	$query .= sprintf(" AND %s.data_id = %s.data_id", DATA_TBL, ROUTE_TBL);
	$query .= sprintf(" AND %s.receive_flg >= 1", ROUTE_TBL);
	$query .= $order_str;
	$db->query($query);
	$row_count = $db->nf();
	
	// ɽԤ
	$start_row = $page * $view_count;
	$end_row = $start_row + $view_count;
	if ($row_count != 0 && $start_row >= $row_count) {
		$page--;
		$start_row = $page * $view_count;
		$end_row = $start_row + $view_count;
	}
	
	// ڡưܥ
	print("<tr><td colspan=\"6\">\n");
	Print_PageMove($start_row, $end_row, $db->nf());
	print("</td></tr>\n");
	
	print("<tr nowrap class=\"color01\" align=\"center\">\n");
	print("<td width=\"10%\"><b></b></td>\n");
	print("<td width=\"15%\"><b></b></td>\n");
	print("<td width=\"30%\"><b>ȥ</b></td>\n");
	print("<td width=\"20%\"><b></b></td>\n");
	print("<td width=\"15%\"><b></b></td>\n");
	print("<td width=\"10%\"><b>ź</b></td>\n");
	print("</tr>\n");
	
	$i = 0;
	while ($db->next_record()) {
		if ($i < $start_row || $i >= $end_row) {
			$i++;
			continue;
		}
		$data_id = $db->f("data_id");
		$status_no = $db->f("status_no");
		$status = $status_array[$status_no];
		$type_name = Get_TypeName($db->f("type_id"));
		$title = sprintf("<a href=\"%s?mode=view&data_id=%s&page=%d&order=%s\">%s</a>", 
					PG_NAME(), $db->f("data_id"), $page, $order, htmlspecialchars($db->f("data_title")));
		$from_member = htmlspecialchars(Get_MemberName($db->f("from_member_id")));
		$date = Format_Date($db->f("receive_date"));
		$receive_flg = $db->f("receive_flg");
		if ($db->f("attach_file_path"))
			$attach_file = sprintf("<img src=\"%s\" boder=\"0\">", CLIP_IMG);
		else
			$attach_file = "<br>";
		printf("<tr bgcolor=\"%s\">\n", BG_COLOR_4);
		if ($receive_flg == 1) {
			printf("<td><img src=\"%s\" border=\"0\"></td>\n", $status_icon_array[$status_no]);
			printf("<td><b>%s</b></td>\n", $type_name);
			printf("<td><b>%s</b></td>\n", $title);
			printf("<td><b>%s</b></td>\n", $from_member);
			printf("<td align=\"center\"><b>%s</b></td>\n", $date);
			printf("<td align=\"center\"><b>%s</b></td>\n", $attach_file);
		} else {
			printf("<td><img src=\"%s\" border=\"0\"></td>\n", $status_icon_array[$status_no]);
			printf("<td>%s</td>\n", $type_name);
			printf("<td>%s</td>\n", $title);
			printf("<td>%s</td>\n", $from_member);
			printf("<td align=\"center\">%s</td>\n", $date);
			printf("<td align=\"center\">%s</td>\n", $attach_file);
		}
		print("</tr>\n");
		$i++;
	}
	
	// ڡưܥ
	print("<tr><td colspan=\"6\">\n");
	Print_PageMove($start_row, $end_row, $db->nf());
	print("</td></tr>\n");

	print("</table>\n");

	$db->close();

	print("</td>\n");
	print("</tr>\n");
	print("</table>\n");
}


//==============================================================
// Function Name    : Print_TransmitIndexPage
//--------------------------------------------------------------
// Note		        : 
//                  :
//==============================================================
Function Print_TransmitIndexPage()
{
	global $JJ_USER_ID, $JJ_USE_DATABASE;
	global $status_array, $status_icon_array;
	global $page, $view_count;
	global $order;

	printf("<table border=\"0\" bgcolor=\"white\" cellpadding=\"5\" cellspacing=\"0\" width=\"%d\">\n", PAGE_WIDTH);
	print("<tr>\n");
	print("<td valign=\"top\" align=\"center\" width=\"100%\">\n");

	print("<table border=\"0\" cellpadding=\"5\" cellspacing=\"2\" width=\"100%\">\n");
	
	print("<tr><td colspan=\"3\">\n");
	Sort_ViewForm($order, 1);
	print("</td><td colspan=\"2\">\n");
	Print_ViewCountForm(1);
	print("</td></tr>\n");
	
	$db = new DB_Test;
	
	// դνϷѹ
	if ($JJ_USE_DATABASE == "postgres")
		$db->query("set datestyle to 'ISO'");
	
	// 
	switch ($order) {
		case "status_u" :
			$order_str = sprintf(" ORDER BY %s.status_no", DATA_TBL);
			break;
		case "type_u" :
			$order_str = sprintf(" ORDER BY %s.type_id", DATA_TBL);
			break;
		case "title_u" :
			$order_str = sprintf(" ORDER BY %s.data_title", DATA_TBL);
			break;
		case "date_u" :
			$order_str = sprintf(" ORDER BY %s.request_date", DATA_TBL);
			break;
		case "file_u" :
			$order_str = sprintf(" ORDER BY %s.attach_file_path", DATA_TBL);
			break;
		case "status_d" :
			$order_str = sprintf(" ORDER BY %s.status_no DESC", DATA_TBL);
			break;
		case "type_d" :
			$order_str = sprintf(" ORDER BY %s.type_id DESC", DATA_TBL);
			break;
		case "title_d" :
			$order_str = sprintf(" ORDER BY %s.data_title DESC", DATA_TBL);
			break;
		case "date_d" :
			$order_str = sprintf(" ORDER BY %s.request_date DESC", DATA_TBL);
			break;
		case "file_d" :
			$order_str = sprintf(" ORDER BY %s.attach_file_path DESC", DATA_TBL);
			break;
		default :
			$order_str = sprintf(" ORDER BY %s.data_id DESC", DATA_TBL);
	}

	$query = sprintf("SELECT * FROM %s WHERE from_member_id = '%s'", DATA_TBL, $JJ_USER_ID);
	$query .= $order_str;
	$db->query($query);
	$row_count = $db->nf();
	
	// ɽԤ
	$start_row = $page * $view_count;
	$end_row = $start_row + $view_count;
	if ($row_count != 0 && $start_row >= $row_count) {
		$page = round($row_count / $view_count) - 1;
		$start_row = $page * $view_count;
		$end_row = $start_row + $view_count;
	}
	
	// ڡưܥ
	print("<tr><td colspan=\"5\">\n");
	Print_PageMove($start_row, $end_row, $db->nf());
	print("</td></tr>\n");

	print("<tr nowrap class=\"color01\" align=\"center\">\n");
	printf("<td width=\"60\"><b></b></td>\n", PG_NAME());
	printf("<td width=\"100\"><b></b></td>\n", PG_NAME());
	printf("<td width=\"300\"><b>ȥ</b></td>\n", PG_NAME());
	printf("<td width=\"100\"><b></b></td>\n", PG_NAME());
	printf("<td width=\"40\"><b>ź</b></td>\n", PG_NAME());
	print("</tr>");

	$i = 0;
	while ($db->next_record()) {
		if ($i < $start_row || $i >= $end_row) {
			$i++;
			continue;
		}
		
		$status_no = $db->f("status_no");
		$status = $status_array[$status_no];
		$type_name = Get_TypeName($db->f("type_id"));
		$title = sprintf("<a href=\"%s?mode=view&data_id=%s&page=%d&order=%s&back_mode=1\">%s</a>",
					PG_NAME(), $db->f("data_id"), $page, $order, htmlspecialchars($db->f("data_title")));
		$transmit_date = Format_Date($db->f("request_date"));
		if ($db->f("attach_file_path"))
			$attach_file = sprintf("<img src=\"%s\" boder=\"0\">", CLIP_IMG);
		else
			$attach_file = "<br>";
		
		printf("<tr bgcolor=\"%s\">\n", BG_COLOR_4);
		if (!Check_CompleteData($db->f("data_id"))) {
			printf("<td><img src=\"%s\" border=\"0\"></td>\n", $status_icon_array[$status_no]);
			printf("<td>%s</td>\n", $type_name);
			printf("<td>%s</td>\n", $title);
			printf("<td align=\"center\">%s</td>\n", $transmit_date);
			printf("<td align=\"center\">%s</td>\n", $attach_file);
		} else {
			printf("<td><img src=\"%s\" border=\"0\"></td>\n", $status_icon_array[$status_no]);
			printf("<td><b>%s</b></td>\n", $type_name);
			printf("<td><b>%s</b></td>\n", $title);
			printf("<td align=\"center\"><b>%s</b></td>\n", $transmit_date);
			printf("<td align=\"center\"><b>%s</b></td>\n", $attach_file);
		}
		print("</tr>\n");
		$i++;
	}
	
	// ڡưܥ
	print("<tr><td colspan=\"5\">\n");
	Print_PageMove($start_row, $end_row, $db->nf());
	print("</td></tr>\n");
	
	$db->close();

	print("</table>\n");

	print("</td>\n");
	print("</tr>\n");
	print("</table>\n");
}


//==============================================================
// Function Name    : Print_CreatePage
//--------------------------------------------------------------
// Note		        : 
//                  :
//==============================================================
Function Print_CreatePage()
{
	global $title, $type_id, $body, $biko, $file, $route_members;
	global $section_id;

	if (!isset($title)) $title = "";
	if (!isset($biko)) $biko = "";
	if (!isset($file)) $file = "";
	if (!isset($body)) $body = "";
	if (!isset($route_members)) $route_members = "";
	if (!isset($section_id)) $section_id = 0;
	
	// JavaScript
	?>
	<script language="JavaScript">
	<!--
		function submit_form(form) {
			if (form.title.value == '') {
				alert('ȥ뤬ϤƤޤ');
				return;
			}
			if (form.body.value == '') {
				alert('ʸϤϤƤޤ');
				return;
			}
			if (form.body.value.length > 2000) {
				alert('ʸϤʸĹޤ');
				return;
			}
			if (form.group_member_id.length < 2) {
				alert('ϩϤƤޤ');
				return;
			}
			form.action.value = 'insert';
			set_route_members(form);
		}
	// -->
	</script>
	<?

	printf("<table border=\"0\" bgcolor=\"white\" cellpadding=\"5\" cellspacing=\"0\" width=\"%d\">\n", PAGE_WIDTH);
	print("<tr><td valign=\"top\" align=\"center\" width=\"100%\">\n");
	
	printf("<form enctype=\"multipart/form-data\" action=\"%s\" method=\"post\">\n", PG_NAME());
	print("<input type=\"hidden\" name=\"action\" value=\"\">\n");
	print("<input type=\"hidden\" name=\"mode\" value=\"\">\n");
	print("<input type=\"hidden\" name=\"MAX_FILE_SIZE\" value=\"1000000\">\n");
	print("<input type=\"hidden\" name=\"route_members\" value=\"\">\n");
	
	print("<table width=\"100%\" border=\"0\" cellpadding=\"5\" cellspacing=\"2\">\n");
	
	print("<tr>\n");
	print("<td nowrap class=\"color01\"><b>ȥ(ɬ)</b></td>\n");
	print("<td bgcolor=\"#f7f2e8\">\n");
	printf("<input type=\"text\" size=\"50\" maxlength=\"50\" name=\"title\" value=\"%s\">\n", $title);
	print("</td>\n");
	print("</tr>\n");
	
	$db = new DB_Test;
	$query = sprintf("SELECT * FROM %s ORDER BY type_id", TYPE_TBL);
	$db->query($query);
	print("<tr>\n");
	print("<td nowrap class=\"color01\"><b></b></td>\n");
	print("<td bgcolor=\"#f7f2e8\"><select name=\"type_id\">\n");
	print("<option value=\"0\">ʤ</option>\n");
	while ($db->next_record()) {
		if (!isset($type_id))	$type_id="";
		if ($type_id == $db->f("type_id"))
			printf("<option value=\"%s\" selected>%s</option>\n", $db->f("type_id"), $db->f("type_name"));
		else
			printf("<option value=\"%s\">%s</option>\n", $db->f("type_id"), $db->f("type_name"));
	}
	print("</select></td>\n");
	print("</tr>\n");
	$db->close();
	
	Get_TemplateList($id_list, $name_list);
	print("<tr>\n");
	print("<td nowrap class=\"color01\"><b>ʸ(ɬ)</b></td>\n");
	print("<td bgcolor=\"#f7f2e8\">\n");
	if (count($id_list) > 0) {
		print("ƥץ졼<select name=\"template_id\">\n");
		for ($i = 0; $i < count($id_list); $i++) {
			printf("<option value=\"%s\">%s</option>\n", $id_list[$i], $name_list[$i]);
		}
		print("</select>\n");
		print("<input type=\"button\" value=\"ƥץ졼Ȥ\" onclick=\"this.form.action.value='body_insert';set_route_members(this.form)\"><br>\n");
	}
	printf("<textarea cols=\"70\" rows=\"20\" wrap=\"hard\" name=\"body\">%s</textarea>\n", $body);
	print("</td>\n");
	print("</tr>\n");
	
	print("<tr>\n");
	print("<td nowrap class=\"color01\"><b></b></td>\n");
	printf("<td bgcolor=\"#f7f2e8\"><textarea cols=\"70\" rows=\"5\" wrap=\"hard\" name=\"biko\">%s</textarea></td>\n",
		$biko);
	print("</tr>\n");
	
	print("<tr>\n");
	print("<td nowrap class=\"color01\"><b>źեե</b></td>\n");
	printf("<td bgcolor=\"#f7f2e8\"><input type=\"file\" name=\"file\" value=\"%s\"></td>\n", $file);
	print("</tr>\n");
	
	print("<tr>\n");
	print("<td nowrap class=\"color01\"><b>ϩ(ɬ)</b></td>\n");
	print("<td bgcolor=\"#f7f2e8\">\n");
	Print_RouteInputForm($section_id, $route_members);
	print("</td>\n");
	print("</tr>\n");
	
	print("<tr><td colspan=\"2\" align=\"center\">\n");
	print("<input type=\"button\" value=\"\" onclick=\"submit_form(this.form);\">\n");
	print("</td></tr>\n");
	
	print("</table></form>\n");
	
	print("</td></tr></table>\n");
}


//==============================================================
// Function Name    : Print_ViewPage
//--------------------------------------------------------------
// Note		        : 
//                  :
//==============================================================
Function Print_ViewPage($data_id)
{
	global $status_array, $status_icon_array;
	global $dir_path;
	global $JJ_USER_ID, $JJ_USE_DATABASE;
	global $back_mode, $order, $page;
	
	printf("<table border=\"0\" bgcolor=\"white\" cellpadding=\"5\" cellspacing=\"0\" width=\"%d\">\n", PAGE_WIDTH);
	print("<tr>\n");
	print("<td valign=\"top\" align=\"center\" width=\"100%\">\n");

	print("<table border=\"0\" cellpadding=\"5\" cellspacing=\"2\">\n");

	$db = new DB_Test;
	
	// դνϷѹ
	if ($JJ_USE_DATABASE == "postgres")
		$db->query("set datestyle to 'ISO'");

	$query = sprintf("SELECT * FROM %s WHERE data_id = '%s'", DATA_TBL, $data_id);
	$db->query($query);
	$db->next_record();
	$from_member_id = $db->f("from_member_id");
	$from_member = htmlspecialchars(Get_MemberName($from_member_id));
	$from_date = Format_Date($db->f("request_date"));
	$type_name = htmlspecialchars(Get_TypeName($db->f("type_id")));
	$title = htmlspecialchars($db->f("data_title"));
	$body_file_path = $db->f("body_file_path");
	$status_no = $db->f("status_no");
	$status = $status_array[$status_no];
	$biko = htmlspecialchars($db->f("biko"));
	$attach_file_path = $db->f("attach_file_path");
	
	$query = sprintf("SELECT receive_flg FROM %s", ROUTE_TBL);
	$query .= sprintf(" WHERE data_id = '%s' AND member_id = '%s'", $data_id, $JJ_USER_ID);
	$db->query($query);
	$receive_flg = "";
	if ($db->nf()){
		$db->next_record();
		$receive_flg = $db->f("receive_flg");
	}
	$db->close();
	
	// δɽ
	if ($status_no != 0 && $JJ_USER_ID == $from_member_id) {
		Read_CompleteData($data_id);
	}

	// եɤ߹
	$fp = fopen($body_file_path, "r");
	$body = fread($fp, 1000000);
	fclose($fp);
	$body = nl2br($body);
	
	print("<tr>\n");
	printf("<td nowrap class=\"color01\"><b></b></td>\n");
	printf("<td bgcolor=\"%s\"><img src=\"%s\" border=\"0\"></td>\n", 
		BG_COLOR_4, $status_icon_array[$status_no]);
	print("</tr>\n");
	
	print("<tr>\n");
	printf("<td nowrap class=\"color01\"><b></b></td>\n");
	printf("<td bgcolor=\"%s\">%s</td>\n", BG_COLOR_4, $from_member);
	print("</tr>\n");
	
	print("<tr>\n");
	printf("<td nowrap class=\"color01\"><b></b></td>\n");
	printf("<td bgcolor=\"%s\">%s</td>\n", BG_COLOR_4, $from_date);
	print("</tr>\n");
	
	print("<tr>\n");
	printf("<td nowrap class=\"color01\"><b></b></td>\n");
	printf("<td bgcolor=\"%s\">%s</td>\n", BG_COLOR_4, $type_name);
	print("</tr>\n");
	
	print("<tr>\n");
	printf("<td nowrap class=\"color01\"><b>ȥ</b></td>\n");
	printf("<td bgcolor=\"%s\">%s</td>\n", BG_COLOR_4, $title);
	print("</tr>\n");
	
	print("<tr>\n");
	printf("<td nowrap class=\"color01\"><b></b></td>\n" );
	printf("<td bgcolor=\"%s\"><pre>%s</pre></td>\n", BG_COLOR_4, $body);
	print("</tr>\n");
	
	print("<tr>\n");
	printf("<td nowrap class=\"color01\"><b>źեե</b></td>\n");
	if ($attach_file_path) {
		printf("<td bgcolor=\"%s\"><a href=\"%s%s\" target=\"blank\"></a></td>\n", 
			BG_COLOR_4, FILE_DIR_NAME, $attach_file_path);
	} else {
		printf("<td bgcolor=\"%s\"><br></td>\n", BG_COLOR_4);
	}
	print("</tr>\n");

	// ɽ
	print("<tr>\n");
	printf("<td nowrap class=\"color01\"><b></b></td>\n");
	if (!$biko)
		$biko = "<br>";
	printf("<td bgcolor=\"%s\">%s</td>\n", BG_COLOR_4, $biko);
	print("</tr>\n");
	
	// ϩɽ
	print("<tr>\n");
	printf("<td nowrap class=\"color01\"><b>ϩ</b></td>\n");
	printf("<td bgcolor=\"%s\">\n", BG_COLOR_4);
	print("<table>\n");
	$route_array = Get_RouteMember($data_id);
	while (list($member_id, $biko) = each($route_array)) {
		print("<tr valign=\"middle\">\n");
		if (Check_CurrentMember($data_id, $member_id) && $status_no == 0)
			printf("<td width=\"100\"><b>%s</b></td>\n", Get_MemberName($member_id));
		else
			printf("<td width=\"100\">%s<br></td>\n", Get_MemberName($member_id));
		printf("<td width=\"400\">%s<br></td>\n", $biko);
		print("</tr>\n");
	}
	print("</table>\n");
	print("</td>\n");
	print("</tr>\n");

	if ($receive_flg == 1 && $status_no == 0) {
		printf("<form action=\"%s\" method=\"post\" name=\"form1\">\n", PG_NAME());
		print("<input type=\"hidden\" name=\"action\" value=\"\">\n");
		printf("<input type=\"hidden\" name=\"data_id\" value=\"%s\">\n", $data_id);
		printf("<input type=\"hidden\" name=\"page\" value=\"%d\"\">\n", $page);
		printf("<input type=\"hidden\" name=\"order\" value=\"%s\"\">\n", $order);
		print("<tr>\n");
		print("<td class=\"color01\"><b></b></td>\n");
		printf("<td align=\"center\" bgcolor=\"%s\">\n", BG_COLOR_4);
		print("<textarea cols=\"70\" rows=\"3\" wrap=\"hard\" name=\"biko2\"></textarea>\n");
		print("</td></tr>\n");
		print("<tr><td colspan=\"2\" align=\"center\">\n");
		print("<input type=\"submit\" value=\"ǧ\" onclick=\"document.form1.action.value='go'\">\n");
		print("<input type=\"submit\" value=\"ǧ\" onclick=\"document.form1.action.value='back'\">\n");	
		print("</td></tr>\n");
		print("</form>\n");
	}
	if ($status_no == 0 && $from_member_id == $JJ_USER_ID) {
		printf("<form action=\"%s\" method=\"post\" name=\"form1\">\n", PG_NAME());
		print("<input type=\"hidden\" name=\"action\">\n");
		printf("<input type=\"hidden\" name=\"data_id\" value=\"%s\">\n", $data_id);
		printf("<input type=\"hidden\" name=\"page\" value=\"%d\"\">\n", $page);
		printf("<input type=\"hidden\" name=\"order\" value=\"%s\"\">\n", $order);
		print("<tr><td colspan=\"2\" align=\"center\">\n");
		print("<input type=\"submit\" value=\"ä\" onclick=\"this.form.action.value='cancel'\">\n");
		print("</td></tr>\n");
		print("</form>\n");
	}

	print("<tr><td colspan=\"2\" align=\"center\">\n");
	printf("<a href=\"%s?mode=%d&page=%d&order=%s\"></a>\n", PG_NAME(), $back_mode, $page, $order);
	print("</td></tr>\n");

	print("</table>\n");

	print("</td></tr>\n");
	print("</table>\n");
}


//==============================================================
// Function Name    : Program_Start
//--------------------------------------------------------------
// Note		        : 
//                  : 
//==============================================================
Login_Start(PG_NAME());//å

$view_count_list = array(10, 25, 50);	// ɽꥹ

// ɽ
if (isset($new_view_count)) {
	setcookie("view_count", $new_view_count);
	$view_count = $new_view_count;
} elseif (!isset($view_count)) {
	$view_count = $view_count_list[0];
}lchk1();

if (!isset($action)) $action = "";
if (!isset($mode)) $mode = "";
if (!isset($page)) $page = 0;
if (!isset($order)) $order = "";
if (!isset($back_mode)) $back_mode = "";

Print_Header();

// ե¸
//$dir_path = $JJ_DOCS_ROOT . $JJ_DIR_NAME . $JJ_DIR_SEP . FILE_DIR_NAME;
$dir_path = $JJ_WORKFLOW_ROOT_FULL;
//Dir_Check($dir_path);

switch ($action) {
	case "insert" :			// 
		if ($file_name)
			File_Save($dir_path);
		Data_Insert();
		$mode = 1;
		break;
	case "go" :				// ǧ
		Approval($data_id, $biko2);
		break;
	case "back" :			// ǧ
		Denial($data_id, $biko2);
		break;
	case "cancel" :			// 󥻥
		Cancel($data_id);
		$mode = 1;
		break;
	case "type_insert" :	// ɲ
		Type_Insert($type_name);
		break;
	case "type_update" :	// ཤ
		Type_Update($type_id, $new_type_name);
		break;
	case "type_delete" :	// 
		Type_Delete($type_id);
		break;
	case "body_insert" :	// 
		$body = Read_Template($template_id);
		$mode = 2;
		break;
}

Print_Menu($mode);

switch ($mode) {
	case "view" :
		Print_ViewPage($data_id);
		break;
	case 2 :	// 
		Print_CreatePage();
		break;
	case 1 :	// 
		Print_TransmitIndexPage();
		break;
	default :	// 
		Print_ReceiveIndexPage();
}

include("common_printfooter.inc");

?>