<?php
//==============================================================
// Program Name		: յǽ
// File Name		: common_hiduke.inc
//--------------------------------------------------------------
// Date             : 2000/08/03
// Author           : M Iura
//--------------------------------------------------------------
// Note				: 
//                  : 
//--------------------------------------------------------------
// Rev.             : 
//                  : 
//==============================================================
//==============================================================
// Function Name    : Last_date($y,$m)
//--------------------------------------------------------------
// Note		        : 
//                  :
//==============================================================
function Last_date($y,$m)
{
	switch ($m) {
		case 2:
			$amari1 = $y % 4;
			$amari2 = $y % 100;
			$amari3 = $y % 400;
	 		if (($amari1 == 0) and ($amari2 != 0) and ($amari3 == 0)){
				$str = 29;
			} else {
				$str = 28;
			}
			break;
		case 4:
		case 6:
		case 9:
		case 11:
			$str = 30;
			break;
		default:
			$str = 31;
			break;
	}

	return ($str);
}

//==============================================================
// Function Name    : Week_ft($hiduke)
//--------------------------------------------------------------
// Note		        : $hidukeνγϽλ
//                  : "9999-99-99"
//                  : list ("9999-99-99","9999-99-99") = Week_ft("9999-99-99");
//==============================================================
function Week_ft($hiduke)
{
	$ymd = explode("-", $hiduke);
	$yy_f  = $yy_t  = $ymd[0];
	$mm_f  = $mm_t  = $ymd[1];
	$dd_f  = $dd_t  = $ymd[2];
	$youbi = Week_no ($hiduke);		//
	//
	if ($dd_f <= $youbi){			//դξ
		$wk = $youbi - $dd_f;
		$mm_f = $mm_f - 1;			//ΤäƤ
		if ($mm_f == 0){
			$yy_f = $yy_f - 1;
			$mm_f = 12;
		}
		$dd_f = Last_date($yy_f,$mm_f);
		$dd_f = $dd_f - $wk;
	} else {
		$dd_f = $dd_f - $youbi;
	}
	//λ
	$wk = 6 - $youbi;
	$dd_t = $dd_t + $wk;
	$wk_last  = Last_date($yy_t,$mm_t);	//Ϸ
	if ($dd_t > $wk_last){				//դ礭ä
		$dd_t = $dd_t - $wk_last;
		$mm_t = $mm_t + 1;				//äƤ
		if ($mm_f > 12){
			$yy_f = $yy_f + 1;
			$mm_t = 1;
		}
	}
	
	$dd_f = sprintf("%02d", $dd_f);
	$dd_t = sprintf("%02d", $dd_t);
	// ˥˽λ
	return array("$yy_f-$mm_f-$dd_f","$yy_t-$mm_t-$dd_t") ;
}

//==============================================================
// Function Name    : Month_ft($hiduke)
//--------------------------------------------------------------
// Note		        : $hidukeηγϽλ
//                  : "9999-99-99"
//                  : list ("9999-99-99","9999-99-99") = Month_ft("9999-99-99");
//==============================================================
function Month_ft($hiduke)
{
	$ymd = explode("-", $hiduke);
	$yy_f  = $yy_t  = $ymd[0];
	$mm_f  = $mm_t  = $ymd[1];
	$dd_f  = $dd_t  = $ymd[2];
	//
	$dd_f = 1;
	//λ
	$dd_t  = Last_date($yy_t,$mm_t);	//Ϸ
	$dd_f = sprintf("%02d", $dd_f);
	$dd_t = sprintf("%02d", $dd_t);
	return array("$yy_f-$mm_f-$dd_f","$yy_t-$mm_t-$dd_t") ;
}

//==============================================================
// Function Name    : Date_from_to($dt,$md)
//--------------------------------------------------------------
// Note		        : $dt$md(D,W,M)γϽλ
//                  : "9999-99-99"
//                  : list ("9999-99-99","9999-99-99") = Month_ft("9999-99-99");
//==============================================================
function Date_from_to($dt,$md)
{
	switch ($md)
	{
//		case SEL_WEEK:
		case "W":
			list ($from_date,$to_date) = Week_ft($dt);
			break;
//		case SEL_MONTH:
		case "M":
			list ($from_date,$to_date) = Month_ft($dt);
			break;
//		case SEL_DAY:
		case "D":
		default:
			$from_date = $dt;
			$to_date   = $dt;
			break;
	}

	return array($from_date,$to_date) ;
}

//==============================================================
// Function Name    : Next_date($y-m-d,"YMD",+-123456789)
//--------------------------------------------------------------
// Note		        : $ymd+-123456789"YMD"׻
//                  : "9999-99-99" = Next_date("9999-99-99","D""M""Y", +-n);
//==============================================================
function Next_date($ymd,$set,$suu)
{
	//ǯʬ
	$chk = explode("-", $ymd);
	$y = $chk[0];
	$m = $chk[1];
	$d = $chk[2];
	
	switch ($set) {
		case "Y"://ǯܡ
			$y = $y + $suu;
			break;
		case "M"://ܡ
			$m = $m + $suu;
			while ($m > 12):
				$m = $m - 12;
				$y = $y + 1;
			endwhile;
			while ($m < 1):
				$y = $y - 1;
				$m = $m + 12;
			endwhile;
			if (!checkdate($m+0,$d+0,$y+0)){
				$d = Last_date($y,$m);
			}
			break;
		case "D"://ܡ
			$d = $d + $suu ;
			while ($d > Last_date($y,$m)):
				$d = $d - Last_date($y,$m);
				$m = $m + 1;
				if ($m > 12){
					$m = 1;
					$y = $y + 1;
				}
			endwhile;
			while ($d < 1):
				$m = $m - 1;
				if ($m < 1){
					$m = 12;
					$y = $y - 1;
				}
				$d = $d + Last_date($y,$m);
			endwhile;
			break;
	}
	
	$str = sprintf("%04d-%02d-%02d", $y, $m, $d);
	//$str = "$y-$m-$d";
	return ($str);
}

//==============================================================
// Function Name    : Week_no($ymd)
//--------------------------------------------------------------
// Note		        : 
//                  :6:SUN 0:MON 1:THU 2:WEN 3:THE 4:fri 5:SUT
//                  :Zeller(ĥ顼ˤθ
//                  :(yyyy+(yyyy/4)-(yyyy/100)+(yyyy/400)+(2.6*mm+1.6)+dd)%7
//                  :       suu1     suu2       suu3       suu4
//==============================================================
function Week_no($ymd)
{
	$chk = explode("-", $ymd);
	$y = $chk[0];
	$m = $chk[1];
	$d = $chk[2];
	
	if (($m == 1) || ($m == 2)){
		$y--;
		$m = $m + 12;
	}
	
	$suu1 = floor($y / 4);
	$suu2 = floor($y / 100);
	$suu3 = floor($y / 400);
	$suu4 = 2.6 * $m;
	$suu4 = floor($suu4 + 1.6);
	
	$suu =  floor(($y + $suu1 - $suu2 + $suu3 + $suu4 + $d) % 7) ;

	return ($suu);
}


//==============================================================
// Function Name    : GetYoubi
//--------------------------------------------------------------
// Note		        : 
//                  : 
//==============================================================
Function GetYoubi($week_no)
{
	switch ($week_no) 
	{
		case 1:	$youbi = "";		break;
		case 2:	$youbi = "";		break;
		case 3:	$youbi = "";		break;
		case 4:	$youbi = "";		break;
		case 5:	$youbi = "";		break;
		case 6:	$youbi = "";		break;
		default:
			$youbi = "";
	}
	
	return $youbi;
}


?>