<?php
//==============================================================
// Program Name 	: common_login
// File Name		: 
//--------------------------------------------------------------
// Date 			: 2000/08/11
// USERNAME 		: M Iura
//--------------------------------------------------------------
// Note 			: 
//					: 
//--------------------------------------------------------------
// Rev. 			: 
//					: 
//==============================================================


if (strtolower($JJ_OUTPUT_CHARSET) == "euc-jp")
{
	define("FROM_CHARSET", "EUC");
}
else
{
	define("FROM_CHARSET", "SJIS");
}
define("TO_CHARSET", "JIS");

require("common_define.inc");	// DEFINE



//==============================================================
// Function Name	: str_kigouchk
//--------------------------------------------------------------
// Note				: ʸå
//					: н	'\<>"
//==============================================================
Function str_kigouchk_login($str)
{
	$wk_str = "";
	for ($x = 0; $x < strlen($str); $x++) {
		switch (substr($str, $x, 1)) {
			case "'" :
				$wk_str .= "'";
				break;
			case "\\" :
				$wk_str .= "\\";
				break;
		}
		$wk_str .= substr($str, $x, 1);
	}

	return ($wk_str);
}


//==============================================================
// Function Name	: PG_NAME
//--------------------------------------------------------------
// Note				: 
//					: "
//==============================================================
Function PG_NAME()
{
	global $PHP_SELF;
	$wk = "";
	$wk = basename($PHP_SELF);
	return ($wk);
}


//==============================================================
// Function Name	: P_Header
//--------------------------------------------------------------
// Note				: HTMLإåɽ
//					:
//==============================================================
Function P_Header($title = "")
{
	global $JJ_USER_ID;
	global $JJ_OUTPUT_CHARSET;
	global $JJ_CSS_NAME, $JJ_CSS_ROOT;
	
	if (isset($JJ_CSS_NAME)) {
		$css_file = $JJ_CSS_ROOT . $JJ_CSS_NAME;
	}
	else {
		$css_file = "./css/jetjob.css";
	}

	print("<HTML>\n");
	print("<HEAD>\n");
	print("<META http-equiv=\"Content-Language\" content=\"ja\">\n");
	print("<META http-equiv=\"Content-Type\" content=\"text/html; charset=$JJ_OUTPUT_CHARSET\">\n");
	print("<LINK REL=STYLESHEET TYPE=\"text/css\" HREF=\"$css_file\">\n");
	print("<TITLE>$title</TITLE>\n");
	printf("<SCRIPT language=\"JavaScript\" src=\"%s\"></SCRIPT>\n", "./js/md5.js");
	print("</HEAD>\n");

	print("<BODY><CENTER>\n");
}


//==============================================================
// Function Name	: P_Footer
//--------------------------------------------------------------
// Note				: HTMLեåɽ
//					:
//==============================================================
Function P_Footer()
{
	print("</CENTER></BODY>\n");
	print("</HTML>\n");
}


//==============================================================
// Function Name	: login_form
//--------------------------------------------------------------
// Note				: եɽ
//					: 
//==============================================================
Function login_form($pg)
{
	global $JJ_CSS_NAME, $JJ_UNM;

	$font_col = "#ffffff";
	if (!isset($JJ_CSS_NAME)) $JJ_CSS_NAME="jetjob.css";
	switch ($JJ_CSS_NAME) {
		case "jetjob_black.css":
			$bg_col = "#696969";
			$src_logo = "img/" . BLACK . "/login_logo.gif";
			$src_welcom = "img/" . BLACK . "/welcome.gif";
			$img_fol = "img/" . BLACK  . "/";
			break;
		case "jetjob_gray.css":
			$bg_col = "#595f6f";
			$src_logo = "img/" . GRAY . "/login_logo.gif";
			$src_welcom = "img/" . GRAY . "/welcome.gif";
			$img_fol = "img/" . GRAY  . "/";
			break;
		case "jetjob_grape.css":
			$bg_col = "#483d8b";
			$src_logo = "img/" . GRAPE . "/login_logo.gif";
			$src_welcom = "img/" . GRAPE . "/welcome.gif";
			$img_fol = "img/" . GRAPE  . "/";
			break;
		case "jetjob_green.css":
			$bg_col = "#297a29";
			$src_logo = "img/" . GREEN . "/login_logo.gif";
			$src_welcom = "img/" . GREEN . "/welcome.gif";
			$img_fol = "img/" . GREEN  . "/";
			break;
		case "jetjob_pink.css":
			$bg_col = "#ff6699";
			$src_logo = "img/" . PINK . "/login_logo.gif";
			$src_welcom = "img/" . PINK . "/welcome.gif";
			$img_fol = "img/" . PINK  . "/";
			break;
		case "jetjob_yelow.css":
			$bg_col = "#ff8c00";
			$src_logo = "img/" . YELOW . "/login_logo.gif";
			$src_welcom = "img/" . YELOW . "/welcome.gif";
			$img_fol = "img/" . YELOW  . "/";
			break;
		case "jetjob_white.css":
			$bg_col = "#8c949c";
			$font_col = "#8c949c";
			$src_logo = "img/" . WHITE . "/login_logo.gif";
			$src_welcom = "img/" . WHITE . "/welcome.gif";
			$img_fol = "img/" . WHITE . "/";
			break;
		default :
			$bg_col = "#7fbddb";
			$src_logo = "img/login_logo.gif";
			$src_welcom = "img/welcome.gif";
			$img_fol = "img/";
			break;
	}


//bgcolor=\"$bg_col\" 


print("<BR>");
print("<table border=\"0\" width=\"640\">");
print("<tr>");
	print("<td align=\"center\" ><img src=\"$src_logo\" width=\"300\" height=\"80\" border=\"0\"></td>");
	print("<td><img src=\"$img_fol" . "moon1.gif\" width=\"74\" height=\"74\" border=\"0\"></td>");
	print("<td><img src=\"$img_fol" . "moon2.gif\" width=\"74\" height=\"74\" border=\"0\"></td>");
	print("<td><img src=\"$img_fol" . "moon3.gif\" width=\"74\" height=\"74\" border=\"0\"></td>");
	print("<td><img src=\"$img_fol" . "moon4.gif\" width=\"74\" height=\"74\" border=\"0\"></td>");
print("</tr>");
print("<tr>");
	print("<td><table border=\"0\" width=\"250\" cellpadding=\"0\" cellspacing=\"2\">");
		print("<tr>");
			print("<td colspan=\"2\" align=\"center\"><BR><img src=\"$src_welcom\" width=\"168\" height=\"45\" border=\"0\"><BR><BR><BR></td>");
			print("<form name=\"login\" action=\"$pg\" method=\"post\">\n");
			print("<input type=\"hidden\" name=\"pass_wk\">\n");

		print("</tr>");
		print("<tr>");
 			print("<td width=\"100\" align=\"center\" valign=\"top\"><font size=\"-1\" color=\"$font_col\">桼̾</font></td>");
 			print("<td><form><input size=\"25\" type=\"text\" maxlength=\"30\" name=\"user\"></td>");
		print("</tr>");
		print("<tr>");
			print("<td align=\"center\" valign=\"top\"><font size=\"-1\" color=\"$font_col\">ѥ</font></td>");
			print("<td><input size=\"25\" type=\"password\" maxlength=\"30\" name=\"pass\"></td></td>");
		print("</tr>");
		print("<tr>");
			print("<TD colspan=\"2\" align=\"right\"><INPUT onClick=\"PassChg(); return true;\" type=\"submit\" value=\"\"></TD>\n");
		print("</form>\n");
		print("</tr>");
	print("</table></td>");
	print("<td><img src=\"$img_fol" . "moon5.gif\" width=\"74\" height=\"74\" border=\"0\"></td>");
	print("<td><img src=\"$img_fol" . "moon6.gif\" width=\"74\" height=\"74\" border=\"0\"></td>");
	print("<td><img src=\"$img_fol" . "moon7.gif\" width=\"74\" height=\"74\" border=\"0\"></td>");
	print("<td><img src=\"$img_fol" . "moon8.gif\" width=\"74\" height=\"74\" border=\"0\"></td>");
print("</tr>");
print("<tr>");
	print("<td></td>");
	print("<td><img src=\"$img_fol" . "moon9.gif\" width=\"74\" height=\"74\" border=\"0\"></td>");
	print("<td><img src=\"$img_fol" . "moon10.gif\" width=\"74\" height=\"74\" border=\"0\"></td>");
	print("<td><img src=\"$img_fol" . "moon11.gif\" width=\"74\" height=\"74\" border=\"0\"></td>");
	print("<td><img src=\"$img_fol" . "moon12.gif\" width=\"74\" height=\"74\" border=\"0\"></td>");
print("</tr>");
	print("<tr>\n");
	print("<td align=\"right\" colspan=\"5\"><br /><font color=\"$font_col\">Copyright&copy; 2000-2007, Aquaplan Networks All Rights Reserved.<br>Maintenance Team : netnee.,Co Ltd. and Niigata Open Source Software Association</font></td>\n");
	print("</tr>\n");
print("</table>");




//	print("<table border=\"0\" cellpadding=\"5\" cellspacing=\"0\">\n");
//	print("<tr>\n");
//	print("<td colspan=\"5\" bgcolor=\"$bg_col\"><img src=\"$src_logo\" width=\"397\" height=\"46\" border=\"0\"></td>\n");
//	print("</tr>\n");
//	print("<tr>\n");
//	print("<td rowspan=\"3\"><img src=\"$src_welcom\" width=\"168\" height=\"45\" border=\"0\">\n");
//	print("<form name=\"login\" action=\"$pg\" method=\"post\">\n");
//	print("<input type=\"hidden\" name=\"pass_wk\">\n");
//	print("<table border=\"0\" cellpadding=\"3\" cellspacing=\"3\">\n");
//	print("<tr>\n");
//	print("<td nowrap><font color=\"$font_col\">桼̾</font></td>\n");
//	print("<td><input type=\"text\" name=\"user\" size=\"20\" value=\"$JJ_UNM\"></td>\n");
//	print("</tr>\n");
//	print("<tr>\n");
//	print("<td><font color=\"$font_col\">ѥ</font></td>\n");
//	print("<td><input type=\"password\" name=\"pass\" size=\"20\"></td>\n");
//	print("</tr>\n");
//	print("<tr>\n");
//	print("<td></td>\n");
//	print("<TD align=\"right\"><INPUT onClick=\"PassChg(); return true;\" type=\"submit\" value=\"\"></TD>\n");
//	print("</tr>\n");
//	print("</table>\n");
//	print("</form>\n");
//	print("</td>\n");
//	print("<td><img src=\"$img_fol" . "moon1.gif\" width=\"74\" height=\"74\" border=\"0\"></td>\n");
//	print("<td><img src=\"$img_fol" . "moon2.gif\" width=\"74\" height=\"74\" border=\"0\"></td>\n");
//	print("<td><img src=\"$img_fol" . "moon3.gif\" width=\"74\" height=\"74\" border=\"0\"></td>\n");
//	print("<td><img src=\"$img_fol" . "moon4.gif\" width=\"74\" height=\"74\" border=\"0\"></td>\n");
//	print("</tr>\n");
//	print("<tr>\n");
//	print("<td><img src=\"$img_fol" . "moon5.gif\" width=\"74\" height=\"74\" border=\"0\"></td>\n");
//	print("<td><img src=\"$img_fol" . "moon6.gif\" width=\"74\" height=\"74\" border=\"0\"></td>\n");
//	print("<td><img src=\"$img_fol" . "moon7.gif\" width=\"74\" height=\"74\" border=\"0\"></td>\n");
//	print("<td><img src=\"$img_fol" . "moon8.gif\" width=\"74\" height=\"74\" border=\"0\"></td>\n");
//	print("</tr>\n");
//	print("<tr>\n");
//	print("<td align=\"right\"><img src=\"$img_fol" . "moon9.gif\" width=\"74\" height=\"74\" border=\"0\"></td>\n");
//	print("<td align=\"right\"><img src=\"$img_fol" . "moon10.gif\" width=\"74\" height=\"74\" border=\"0\"></td>\n");
//	print("<td align=\"right\"><img src=\"$img_fol" . "moon11.gif\" width=\"74\" height=\"74\" border=\"0\"></td>\n");
//	print("<td align=\"right\"><img src=\"$img_fol" . "moon12.gif\" width=\"74\" height=\"74\" border=\"0\"></td>\n");
//	print("</tr>\n");
//	print("<tr>\n");
//	print("<td align=\"right\" colspan=\"5\"><font color=\"$font_col\">(C)Copyright aquaplan networks 2000-2002 All Rights Reserved</font></td>\n");
//	print("</tr>\n");
//	print("</table>\n");

	// Javaץȵ
?>
<script language="JavaScript">
<!--
document.login.user.focus();
// -->
</script>
<?php

}


//==============================================================
// Function Name	: P_Form
//--------------------------------------------------------------
// Note				: ϥեɽ
//					: 
//==============================================================
Function P_Form($er="", $pg)
{
	global $JJ_USER_ID, $JJ_UNM;
	global $user, $pass_wk;


	// Javaץȵ
?>
	<script language="JavaScript">
	<!--
	function PassChg()
	{
		document.login.pass_wk.value = MD5(document.login.pass.value);
		document.login.submit();
	}
	// -->
	</script>


<?php
//	include("common_login.ihtml");
	if (!isset($JJ_USER_ID))
		$JJ_USER_ID="";
	if ($JJ_USER_ID == ""){
//		include("common_login2.html");
		login_form($pg);
	}

	if ($er == "NG") {
		//print("<P><font color=red><B>桼ϤǤ˥󤷤Ƥޤ</B></font>\n");
		//print("<P><font color=red><B>ťϤǤޤ</B></font>\n");
		print("<br /><font color=red>桼̾ޤϥѥɤְäƤޤ</font><br />\n");
		print("<font color=red>Ͼǧ٥󤷤Ƥ</font>\n");
	} else {
		if (!isset($JJ_USER_ID)){
			if ((isset($user)) || (isset($pass_wk))) {
				if ($er != "") {
					print("<br /><font color=red>桼̾ޤϥѥɤְäƤޤ</font><br />\n");
					print("<font color=red>Ͼǧ٥󤷤Ƥ</font>\n");
				} 
			}
		}else{
			if (!isset($pass_wk))
				$pass_wk="";
			if ($pass_wk != "") {
				if ($er != "") {
					print("<br /><font color=red>桼̾ޤϥѥɤְäƤޤ</font><br />\n");
					print("<P><font color=red>Ͼǧ٥󤷤Ƥ</font>\n");
				}
			}
		}
	}
}


//==============================================================
// Function Name	: char_check($user, $pass)
//--------------------------------------------------------------
// Note				: ϥ饯å
//					:
//==============================================================
Function char_check($u)
{
	global $pass;
	
	for ($x=0; $x<strlen($u); $x++){
		$chk = substr($u, $x, 1);
		if (($chk < "A") || ($chk > "Z")){
			if (($chk < "a") || ($chk > "z")){
				if (($chk < "0") || ($chk > "9")){
					return ;
				}
			}
		}
	}
	for ($x=0; $x<strlen($pass); $x++){
		$chk = substr($pass, $x, 1);
		if (($chk < "A") || ($chk > "Z")){
			if (($chk < "a") || ($chk > "z")){
				if (($chk < "0") || ($chk > "9")){
					return ;
				}
			}
		}
	}
	return ("OK");
}


//==============================================================
// Function Name	: Check_Login
//--------------------------------------------------------------
// Note				: ϥå
//					:
//==============================================================
Function Check_Login($user, $pass)
{
	$ERR = "";
	if (($user != "") || ($pass != "")) {
		$ERR = char_check($user);
		if ($ERR == "OK"){
			$ERR = "";
			$X = new DB_Test;
			$str = "SELECT * FROM common_passwd";
			$str .= sprintf(" WHERE username = '%s' AND password = '%s'", $user, $pass);
			$X->query($str);
			if ($X->nf() <= 0)
				$ERR = "NG";
			$X->close();
		} else {
			$ERR = "NG";
		}
	}
	return $ERR;
}


//==============================================================
// Function Name	: Get_name
//--------------------------------------------------------------
// Note				: 桼̾
//					:
//==============================================================
Function Get_name($nm)
{

	$X = new DB_Test;

	$str = sprintf("SELECT * FROM common_member WHERE login_name = '%s' ",str_kigouchk_login($nm));
	$X->query($str);
	$nm = "";
	if ($X->nf() > 0){
		$X->next_record();
		$nm = $X->f("member_name");
	}
	$X->close();
	return $nm;
}


//==============================================================
// Function Name	: Get_member_id
//--------------------------------------------------------------
// Note				: 桼ɣļ
//					:
//==============================================================
Function Get_member_id($id)
{
	$db = new DB_Test;
	$query = sprintf("SELECT * FROM common_member WHERE login_name = '%s'",str_kigouchk_login($id));
	$db->query($query);
	$ret = "";
	if ($db->nf() > 0){
		$db->next_record();
		$ret = $db->f("member_id");
	}
	$db->close();
	return($ret);
}


//==============================================================
// Function Name	: Htdocs_set
//--------------------------------------------------------------
// Note				: ƥեΥѥ
//					:
//==============================================================
Function Htdocs_set()
{
	return;
}


//==============================================================
// Function Name	: Color_set
//--------------------------------------------------------------
// Note				: ۿãӣ
//					:
//==============================================================
Function Color_set()
{
	global $JJ_USER_ID, $css_name;

	$db = new DB_Test;

	$db->query("SELECT * FROM usrstng_color WHERE member_id  = '$JJ_USER_ID'");
	$col = "";
	if ($db->nf() > 0){
		$db->next_record();
		$col = $db->f("color_patarn");
	}
	$db->close();

	switch ($col) {
		case BLACK:
			$css_name = "jetjob_black.css";
			break;
		case GRAY:
			$css_name = "jetjob_gray.css";
			break;
		case GRAPE:
			$css_name = "jetjob_grape.css";
			break;
		case GREEN:
			$css_name = "jetjob_green.css";
			break;
		case PINK:
			$css_name = "jetjob_pink.css";
			break;
		case WHITE:
			$css_name = "jetjob_white.css";
			break;
		case YELOW:
			$css_name = "jetjob_yelow.css";
			break;
		default  :
			$css_name = "jetjob.css";
			break;
	}
	$agent = GetUserAgent();
//	setcookie("JJ_CSS_NAME");
	if ($agent["Browser_Name"] == "MSIE" && $agent["Browser_Version"] >= "5.5"){
		setcookie("JJ_CSS_NAME", $css_name);
	}else{
		if ($agent["Browser_Platform"] == "Macintosh"){
			setcookie("JJ_CSS_NAME", $css_name);
		}else{
			setcookie("JJ_CSS_NAME", $css_name, time()+604800);	//å˿ãӣӣɣĽ񤭹
		}
	}
	return;
}


//==============================================================
// Function Name	: Update_PasswordTable
//--------------------------------------------------------------
// Note 			: 
//					: 
// 					: 
//==============================================================
Function Update_PasswordTable($user_id)
{
	$db = new DB_Test;
	
	$query = sprintf("UPDATE common_passwd SET login = '1' WHERE user_id = '%s'", $user_id);
	$db->query($query);
	$db->close();
}


//==============================================================
// Function Name	: GetUserAgent
//--------------------------------------------------------------
// Note 			: 
//					: 
//					: 
//==============================================================
function GetUserAgent()
{
	$HTTP_USER_AGENT = getenv("HTTP_USER_AGENT");

	$user_agent = array();

	$user_agent["HTTP_USER_AGENT"] = $HTTP_USER_AGENT;
	$user_agent["Browser_Name"] = strtok($HTTP_USER_AGENT,	"/"); 
	$user_agent["Browser_Version"] = strtok(" "); 

	// MSIE lies about its name 
	if (ereg("MSIE", $HTTP_USER_AGENT)) 
	{ 
		$user_agent["Browser_Name"] =  "MSIE"; 
		$user_agent["Browser_Version"] = strtok("MSIE"); 
		$user_agent["Browser_Version"] = strtok(" "); 
		$user_agent["Browser_Version"] = strtok(";"); 
	} 

	// Opera isn't completely honest, either ... 
	// Modificaton by Chris Mospaw <mospaw@polk-county.com> 
	if (ereg("Opera", $HTTP_USER_AGENT)) 
	{ 
		$user_agent["Browser_Name"] =  "Opera"; 
		$user_agent["Browser_Version"] = strtok("Opera"); 
		$user_agent["Browser_Version"] = strtok("/"); 
		$user_agent["Browser_Version"] = strtok(";"); 
	} 


	// try to figure out what platform, windows or mac 
	$user_agent["Browser_Platform"] =  "unknown"; 
	if (ereg("Windows", $HTTP_USER_AGENT) ||  
		ereg("WinNT", $HTTP_USER_AGENT) || 
		ereg("Win98", $HTTP_USER_AGENT) || 
		ereg("Win95", $HTTP_USER_AGENT)) 
	{ 
		$user_agent["Browser_Platform"] = "Windows"; 
	}	
	 
	if (ereg("Mac", $HTTP_USER_AGENT)) 
	{ 
		$user_agent["Browser_Platform"] = "Macintosh"; 
	} 

	if (ereg("X11", $HTTP_USER_AGENT))	
	{
		$user_agent["Browser_Platform"] = "Unix";  
	}  

	//default to no JavaScript or CSS support 
	$user_agent["Browser_JavaScriptOK"] = FALSE; 
	$user_agent["Browser_CSSOK"] = FALSE; 
	$user_agent["Browser_FileUpload"] = FALSE; 

	if ($user_agent["Browser_Platform"] == "Windows") 
	{ 
		if ($user_agent["Browser_Name"] == "Mozilla") 
		{ 
			if ($user_agent["Browser_Version"] >= 3.0) 
			{ 
				$user_agent["Browser_JavaScriptOK"] = TRUE; 
				$user_agent["Browser_FileUpload"] = TRUE; 
			}		  
			if ($user_agent["Browser_Version"] >= 4.0) 
			{ 
				$user_agent["Browser_CSSOK"] = TRUE; 
			} 
		} 
		else if ($user_agent["Browser_Name"] == "MSIE") 
		{ 
			if ($user_agent["Browser_Version"] >= 4.0) 
			{ 
				$user_agent["Browser_JavaScriptOK"] = TRUE; 
				$user_agent["Browser_FileUpload"] = TRUE; 
				$user_agent["Browser_CSSOK"] = TRUE; 
			}
		} 
		else if ($user_agent["Browser_Name"] == "Opera") 
		{ 
			if ($user_agent["Browser_Version"] >= 3.0) 
			{ 
				$user_agent["Browser_JavaScriptOK"] = TRUE; 
				$user_agent["Browser_FileUpload"] = TRUE; 
				$user_agent["Browser_CSSOK"] = TRUE; 
			}
		} 
	} 
	else if ($user_agent["Browser_Platform"] == "Macintosh") 
	{ 
		if ($user_agent["Browser_Name"] == "Mozilla") 
		{ 
			if ($user_agent["Browser_Version"] >= 3.0) 
			{ 
				$user_agent["Browser_JavaScriptOK"] = TRUE; 
				$user_agent["Browser_FileUpload"] = TRUE; 
			}
			if ($user_agent["Browser_Version"] >= 4.0) 
			{ 
				$user_agent["Browser_CSSOK"] = TRUE; 
			} 
		} 
		else if ($user_agent["Browser_Name"] == "MSIE") 
		{ 
			if ($user_agent["Browser_Version"] >= 4.0) 
			{ 
				$user_agent["Browser_JavaScriptOK"] = TRUE; 
				$user_agent["Browser_CSSOK"] = TRUE; 
				$user_agent["Browser_FileUpload"] = TRUE; 
			}
		} 
	} 
	else if ($user_agent["Browser_Platform"] == "Unix")  
	{  
		if ($user_agent["Browser_Name"] == "Mozilla")  
		{  
			if ($user_agent["Browser_Version"] >= 3.0)	
			{  
				$user_agent["Browser_JavaScriptOK"] = TRUE;  
				$user_agent["Browser_FileUpload"] = TRUE;  
			}
			if ($user_agent["Browser_Version"] >= 4.0)	
			{  
				$user_agent["Browser_CSSOK"] = TRUE;
			} 
		}  
	} 

	return $user_agent;
}


//==============================================================
// Function Name	: Login_Start
//--------------------------------------------------------------
// Note 			: 
//					: 
// $JJ_login		: ɽե饰  ɽ"X"  ɽʤ""  Ȥ
//==============================================================
Function Login_Start($pg)
{
	global $user, $pass_wk, $JJ_USERNAME,	$JJ_PASSWORD;
	global $pmis, $uid,  $JJ_PERMISSION, $JJ_USER_ID;
	global $JJ_LOGIN_CNT, $JJ_SYS_PAS;
	
	if (!isset($wk))
		$wk  = "";		//å̾
	if (!isset($wkp))
		$wkp = "";		//åѡߥå
	if (!isset($cnt))
		$cnt = "";		//å󥫥ȼ
	$wk  = (isset($JJ_USERNAME))?$JJ_USERNAME:"";		//å̾
	$wkp = (isset($JJ_PERMISSION))?$JJ_PERMISSION:"";		//åѡߥå
	$cnt = (isset($JJ_LOGIN_CNT))?$JJ_LOGIN_CNT:"";		//å󥫥ȼ
	
	$CHK="";
	if ($wk != ""){
		$user = $wk;
		$pmis = $wkp;
		$cock = "ON";
	} else {
		$CHK = "OFF";
		if ((isset($user)) || (isset($pass_wk))){
			$CHK = Check_Login($user, $pass_wk);
			$cock = "OF";
		}
	}

	if ($CHK != "") {
		if (!isset($JJ_USER_ID)){
			P_Header("Welcome to JET/JOB");
		}else{
			P_Header("JET/JOB Form Lock");
		}
		P_Form($CHK, $pg);
		P_Footer();
		exit;
	} else {
		$db = new DB_Test;
		$str = sprintf("SELECT * FROM common_passwd WHERE username='%s' AND password='$pass_wk'",
								str_kigouchk_login($user));
		$db->query($str);
//		$pmis="";
		if ($db->nf() > 0){
			$db->next_record();
			$pmis = $db->f("perms");
		}
		//Color_set();

// -- 2007/02/09 netnee ikarashi from
		$db->close();
// -- 2007/02/09 netnee ikarashi to

		if ($cock == "OF"){
			Htdocs_set();
			$JJ_USERNAME = $user;
			$JJ_PASSWORD = $pass_wk;
			$JJ_PERMISSION = $pmis;
			$uname = Get_name($JJ_USERNAME);
			$uid = Get_member_id($JJ_USERNAME);
			$JJ_USERNAME_NAME = $uname;
			$JJ_USER_ID = $uid;
			setcookie("JJ_USERNAME", $user);	//å˥̾񤭹
			setcookie("JJ_PERMISSION", $pmis);	//å˥ѡߥå񤭹
			setcookie("JJ_USERNAME_NAME", $uname);	//å˥̾񤭹
			setcookie("JJ_USER_ID", $uid);	//å˥桼ɣĽ񤭹
			// Update_PasswordTable($JJ_USER_ID);
			$agent = GetUserAgent();
			// ʣ2592000
			// ǯʣ31536000
	//		if ($agent["Browser_Name"] == "MSIE" && $agent["Browser_Version"] >= "5.5"){
	//			setcookie("JJ_UNM", "$JJ_USERNAME", time()+2592000);
	//		}else{
	//			if ($agent["Browser_Platform"] == "Macintosh"){
	//				setcookie("JJ_UNM", "$JJ_USERNAME", time()+2592000);
	//			}else{
					setcookie("JJ_UNM", "$JJ_USERNAME", time()+31536000);
	//			}
	//		}
		}
//		$db->close();		// -- 2007/02/09 netnee ikarashi : comment out
		$cnt = $cnt + 1;
		$JJ_LOGIN_CNT = $cnt;
		setcookie("JJ_LOGIN_CNT","$cnt");	//å˥󥫥Ƚ񤭹

		Color_set();
	}
}

?>
