<?php
//==============================================================
// Program Name		: ɽ
// File Name		: print_callendar.inc
//--------------------------------------------------------------
// Date             : 2000/08/04
// Author           : M Iura
//--------------------------------------------------------------
// Note				: 
//                  : 
//--------------------------------------------------------------
// Rev.             : 2000/10/03 Update
//                  : 
//==============================================================

if (!defined("LEFT_GIF"))
	define("LEFT_GIF",  "$JJ_IMG_ROOT" . "body" . "$JJ_DIR_SEP" . "back.gif");	// ɽư 
if (!defined("RIGHT_GIF"))
	define("RIGHT_GIF", "$JJ_IMG_ROOT" . "body" . "$JJ_DIR_SEP" . "fore.gif");	// ɽư 


//==============================================================
// Function Name    : IsHoliday
//--------------------------------------------------------------
// Note		        : 
//                  : 
//==============================================================
Function IsHoliday($year, $month, $day)
{
	global $JJ_DATETIME_SEP;

	$db = new DB_Test;
	$sql = sprintf("SELECT hi FROM common_callender WHERE hi = '%04d%s%02d%s%02d'", 
			$year, $JJ_DATETIME_SEP, $month, $JJ_DATETIME_SEP, $day);
	$db->query($sql);
	if ($db->nf() > 0)
		$ret = true;
	else
		$ret = false;
	$db->close();
	
	return $ret;
}


//==============================================================
// Function Name    : print_callendar
//--------------------------------------------------------------
// Note		        : 
//                  : 
//==============================================================
Function print_callendar($pgm, $mst, $sel = "", $target = "_self", $link_str = "")
{
	global $hiduke;
	global $PHP_SELF;

	if(!isset($hiduke))
		$hiduke="";
	if (!$hiduke) {
		$hiduke = date("Y-m-d");
	}

	$ymd = explode("-", $hiduke);
	$y  = $ymd[0];
	$m  = $ymd[1];
	$d  = $ymd[2];
	list ($f_date,$t_date) = Month_ft($hiduke);
	$ymd = explode("-", $f_date);
	$f_y  = $ymd[0];
	$f_m  = $ymd[1];
	$f_d  = $ymd[2];
	$ymd = explode("-", $t_date);
	$t_y  = $ymd[0];
	$t_m  = $ymd[1];
	$t_d  = $ymd[2];

	$today = Get_Today();

	$mv_date_b = Next_date($hiduke,"M",-1);
	$mv_date_a = Next_date($hiduke,"M", 1);

	print("<table border=\"1\" cellpadding=\"2\" cellspacing=\"0\" bgcolor=\"#f7f2e8\">\n");
	print("<tr><td colspan=\"7\" align=\"center\" class=\"color00\">\n");
	// selͽ modeͽ!!!!!
	printf("<a href=\"%s?sel=%s&mst=%s&hiduke=%s%s\" target=\"%s\"><img src=\"%s\" alt=\"\" height=\"11\" width=\"11\" border=\"0\" hspace=\"10\"></a>\n", 
		$pgm, $sel, $mst, $mv_date_b, $link_str, $target, LEFT_GIF);
	printf("<font color=\"white\"><b>%dǯ% 2d</b></font>\n", $y, $m);
	printf("<a href=\"%s?sel=%s&mst=%s&hiduke=%s%s\" target=\"%s\"><img src=\"%s\" alt=\"\" height=\"11\" width=\"11\" border=\"0\" hspace=\"10\"></a>\n", 
		$pgm, $sel, $mst, $mv_date_a, $link_str, $target, RIGHT_GIF);
	print("</td></tr>\n");
	
	print("<tr align=\"center\" class=\"color02\">\n");
	print("<td><font color=\"#ff3366\"></font></td>\n");
	print("<td></td>\n");
	print("<td></td>\n");
	print("<td></td>\n");
	print("<td></td>\n");
	print("<td></td>\n");
	print("<td></td>\n");
	print("</tr>\n");
	
	$col_flg = 0;
	for ($i = $f_d+0; $i <= $t_d+0; $i++){
		if (!$col_flg) {
			print("<tr align=\"right\">\n");
		}
		
		if ($i == $f_d+0){	//
			for ($x = 0; $x < Week_no($f_date); $x++) {
				print("<td>&nbsp;</td>\n");
				$col_flg++;
			}
		}
		$we = Week_no("$y-$m-$i");
		$col = "black";
		if ($we == 0 || IsHoliday($y, $m, $i)) 
		{
			$col = "#ff3366";
		}
		if ($d == $i) {
			$col = "blue";
		}
		$link_date = sprintf("%s-%s-%d", $y, $m, $i);
		printf("<td><a href=\"%s?hiduke=%s&sel=%s&mst=%s&%s\" target=\"%s\"><font color=\"%s\">$i</font></a></td>\n", 
			$pgm, $link_date, $sel, $mst, $link_str, $target, $col, $i);

		$col_flg++;
		
		if ($col_flg >= 7) {
			print("</tr>\n");
			$col_flg = 0;
		}
	}
	if ($col_flg) {
		while ($col_flg < 7) {
			print("<td>&nbsp;</td>\n");
			$col_flg++;
		}
		print("</tr>\n");
	}
	
	printf("<tr><td colspan=\"7\" bgcolor=\"#cccccc\" nowrap>");
	printf("<a href=\"%s?hiduke=%s&sel=%s&mst=%s%s\" target=\"%s\"></a>%dǯ% 2d% 2dǤ", 
		$pgm, $today, $sel, $mst, $link_str, $target, date("Y"), date("m"), date("d"));
	printf("</td></tr>\n");
	print("</table>\n");
}


//==============================================================
// Function Name    :
//--------------------------------------------------------------
// Note		        :
//                  :
//==============================================================
Function Get_Today($flg=0)
{
	$month_array = array("Jan" => 1, "Feb" => 2, "Mar" => 3, "Apr" => 4, "May" => 5, "Jun" => 6,
						 "Jul" => 7, "Aug" => 8, "Sep" => 9, "Oct" => 10, "Nov" => 11, "Dec" => 12);

	$tz = sprintf(" +%02d%02d", intval(date("Z", time()) / 3600), intval(date("Z", time()) % 3600));
	$today1 = date("D, j M Y H:i:s", time());
	$today1 .= $tz;

	$date_array = explode(" ", $today1);
	//$date = sprintf("%04d/%02d/%02d %s", $date_array[3], $month_array[$date_array[2]], $date_array[1], $date_array[4]);
	if ($flg)
		$today = sprintf("%04dǯ%02d%02d", $date_array[3], $month_array[$date_array[2]], $date_array[1]);
	else
		$today = sprintf("%04d-%02d-%02d", $date_array[3], $month_array[$date_array[2]], $date_array[1]);

	return $today;
}


?>