<?php
//==============================================================
// Program Name		: common_uucode_util.inc
// File Name		: common_uucode_util.inc
//--------------------------------------------------------------
// Date				: 
// Author			: 
//--------------------------------------------------------------
// Note				: 
//					: 
//--------------------------------------------------------------
// Rev.				: 
//					: 
//==============================================================
//if ($UUCODE_INC) return;

$UUCODE_INC= "defined";


//==============================================================
// Function Name	: 
//--------------------------------------------------------------
// Note				: 
//					: 
//==============================================================
	function DEC($p) 
	{
		$result = ($p - 32) & 077;
		return $result; 
	}


//==============================================================
// Function Name	: 
//--------------------------------------------------------------
// Note				: 
//					: 
//==============================================================
	function outdec($buf, $pos, &$c1, &$c2, &$c3)
	{
		$p1 = ord($buf[$pos]);
		$p2 = ord($buf[$pos+1]);
		$p3 = ord($buf[$pos+2]);
		$p4 = ord($buf[$pos+3]);

		$c1 = DEC($p1) << 2 | DEC($p2) >> 4;
		$c2 = DEC($p2) << 4 | DEC($p3) >> 2;
		$c3 = DEC($p3) << 6 | DEC($p4);
	}


//==============================================================
// Function Name	: 
//--------------------------------------------------------------
// Note				: 
//					: 
//==============================================================
	function uudecode($in_array)
	{
		$result = "";
		for ($i = 1; $i < count($in_array); $i++)
		{
			$buf = $in_array[$i];
			$p = ord($buf[0]);
			$n1 = DEC($p);
			if ($n1 <= 0) break;

			$buf1 = substr($buf, 1);
			$pos = 0;
			//printf("[%d][%s]<br>\n", $n1, $buf1);
			while ($n1 > 0)
			{
				$buf2 = outdec($buf1, $pos, $c1, $c2, $c3);
				if ($n1 >= 1) 
				{
					//printf("[%04x]", $c1);
					$result .= chr($c1);
				}
				if ($n1 >= 2)
				{
					//printf("[%04x]", $c2);
					$result .= chr($c2);
				}
				if ($n1 >= 3)
				{
					//printf("[%04x]", $c3);
					$result .= chr($c3);
				}
				//printf("n1=[%d]<br>", $n1);
				$pos += 4;
				$n1 -= 3;
			}
		}
		return $result;
	}


//==============================================================
// Function Name	: 
//--------------------------------------------------------------
// Note				: 
//					: 
//==============================================================
	function ENC($p) 
	{
		$result = ($p & 077) + 32;
		return $result; 
	}


//==============================================================
// Function Name	: 
//--------------------------------------------------------------
// Note				: 
//					: 
//==============================================================
	function outenc($buf, $pos, &$c1, &$c2, &$c3, &$c4)
	{
		$p1 = ord($buf[$pos]);
		$p2 = ord($buf[$pos+1]) ;
		$p3 = ord($buf[$pos+2]);

		$t1 = $p1 >> 2;
		$t2 = ($p1 << 4) & 060 | ($p2 >> 4) & 017;
		$t3 = ($p2 << 2) & 074 | ($p3 >> 6) & 03;
		$t4 = $p3 & 077;

		$c1 = ENC($t1);
		$c2 = ENC($t2);
		$c3 = ENC($t3);
		$c4 = ENC($t4);
	}


//==============================================================
// Function Name	: 
//--------------------------------------------------------------
// Note				: 
//					: 
//==============================================================
	function fr(&$buf, $pos, &$result)
	{
		$result = "";
		$len = strlen($buf) - $pos;
		$cnt = ($len >= 45) ? 45 : $len;
		$result = substr($buf, $pos, $cnt+1);
		return $cnt;
	}


//==============================================================
// Function Name	: 
//--------------------------------------------------------------
// Note				: 
//					: 
//==============================================================
	function uuencode($in_array)
	{
		$pos = 0;
		$result = "";
		$buf = implode("", $in_array);

		for (;;)
		{
			$cnt = fr($buf, $pos, $wbuf);
			$result .= chr(ENC($cnt));
			for ($j = 0; $j < $cnt; $j += 3)
			{
				outenc($wbuf, $j, $c1, $c2, $c3, $c4);
				$result .= chr($c1) . chr($c2) . chr($c3) . chr($c4);
			}
			$result .= chr(13) . chr(10);
			if ($cnt <= 0) break;
			$pos += $cnt;
		}
		return $result;
	}


?>